Attribute VB_Name = "APICalls"
Option Explicit

Global lpPrevWndProc As Long

Private pMinX As Long
Private pMinY As Long
Private pMaxX As Long
Private pMaxY As Long

Public Const LOCALE_SDECIMAL As Long = &HE
Public Const LOCALE_SSHORTDATE As Long = &H1F
Private Const GWL_WNDPROC As Long = -4
Private Const WM_GETMINMAXINFO As Long = &H24

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type MINMAXINFO
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type

Private Declare Sub CopyMemoryToMinMaxInfo Lib "KERNEL32" Alias "RtlMoveMemory" (hpvDest As MINMAXINFO, ByVal hpvSource As Long, ByVal cbCopy As Long)
Private Declare Sub CopyMemoryFromMinMaxInfo Lib "KERNEL32" Alias "RtlMoveMemory" (ByVal hpvDest As Long, hpvSource As MINMAXINFO, ByVal cbCopy As Long)

Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetUserDefaultLCID Lib "KERNEL32" () As Long
Private Declare Function GetLocaleInfo Lib "KERNEL32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long

Public Function GetUserLocaleInfo(ByVal LocaleType As Long) As String

    Dim LocaleID As Long
    Dim Returned As String
    Dim Result As Long

    LocaleID = GetUserDefaultLCID()
    Result = GetLocaleInfo(LocaleID, LocaleType, Returned, Len(Returned))
    
    If Result > 0 Then
    
      Returned = Space(Result)
      Result = GetLocaleInfo(LocaleID, LocaleType, Returned, Len(Returned))

      If Result > 0 Then GetUserLocaleInfo = Left(Returned, Result - 1)
   
   End If
    
End Function

Public Sub SetFormLimits(hWnd As Long, MinX As Integer, MinY As Integer, MaxX As Integer, MaxY As Integer)
  
    pMinX = MinX / Screen.TwipsPerPixelX
    pMinY = MinY / Screen.TwipsPerPixelY
    pMaxX = MaxX / Screen.TwipsPerPixelX
    pMaxY = MaxY / Screen.TwipsPerPixelY
  
    lpPrevWndProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf WindowProc)

End Sub

Public Sub UnsetFormLimits(hWnd As Long)
    
    SetWindowLong hWnd, GWL_WNDPROC, lpPrevWndProc

End Sub

Function WindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

    Dim MinMax As MINMAXINFO

    If uMsg = WM_GETMINMAXINFO Then
        CopyMemoryToMinMaxInfo MinMax, lParam, Len(MinMax)
        MinMax.ptMinTrackSize.x = pMinX
        MinMax.ptMinTrackSize.y = pMinY
        MinMax.ptMaxTrackSize.x = pMaxX
        MinMax.ptMaxTrackSize.y = pMaxY
        CopyMemoryFromMinMaxInfo lParam, MinMax, Len(MinMax)
        WindowProc = DefWindowProc(hw, uMsg, wParam, lParam)
    Else
        WindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
    End If

End Function
