Attribute VB_Name = "General"
DefInt A-Z

' Global Variables
Public gVersion As String                ' Program version number
Public gCompNum As Integer               ' Number of competitions
Public gRdrFile As String                ' Location of Rider Database
Public gDefMaxAvge As Integer            ' Default conversion factor for rider averages
Public gDefScoringType As Integer        ' Default scoring scheme
Public gDefStartPrefs As Integer         ' Default starting gate preferences
Public gDefHomeAdv As Integer            ' Default setting for home advantage
Public gDefControl() As Integer          ' Default mode for running meetings
Public gDefHeatCode() As String          ' Default Programme Marking symbols
Public gDecSep As String                 ' Locale decimal separator
Public gDateFmt As String                ' Locale date format
Public gIniProc As Integer               ' Determines procedure to call upon initialisation
Public gAutoload As String               ' Passes the names of files to open
Public gFindText As String               ' Search string
Public gMatchWord As Integer             ' Determines whether case sensitivity applies when searching
Public gMatchCase As Integer             ' Determines whether to match only whole words when searching

Public gNumTeams As Integer              ' Number of teams
Public gNumGroups As Integer             ' Number of groups
Public gDisplayGrps As Integer           ' Number of teams/groups to display
Public gNumRiders As Integer             ' Number of riders
Public gResType As Integer               ' Type of reserve use
Public gNumRes As Integer                ' Number of reserves
Public gMinRides As Integer              ' Number of compulsory rides
Public gMaxRides As Integer              ' Maximum rides
Public gMaxResRides As Integer           ' Maximum reserve rides
Public gResEnable As Integer             ' Permissible reserve usage
Public gStartPen As Integer              ' Penalty for starting offences
Public gRunoffUse As Integer             ' Type of runoffs to hold
Public gCheckPos As Integer              ' Position to start checking for ties
Public gAddBonus As Integer              ' Whether to add bonus points to team scores
Public gTacSubs As Integer               ' Whether tactical substitutions are available
Public gTacEnable As Integer             ' Tactical substitution arrears
Public gRdrRep As Integer                ' Whether Rider Replacement is available
Public gTeamRes As Integer               ' Whether Team Reserve is available
Public gSpclRaces As Integer             ' Whether special race option is available
Public gSpclTitle As String              ' Title for special race option
Public gHandicaps() As Integer           ' Handicapping scheme
Public gHeatCode() As String             ' Programme marking symbols
Public gScoringType As Integer           ' Scoring scheme
Public gMaxAvge As Integer               ' Meeting conversion factor for rider averages
Public gCompID() As String               ' Competition identification

Public gInteractive As Integer           ' Flags interactive mode
Public gControl() As Integer             ' Mode for running meeting
Public gStartPrefs As Integer            ' Starting gate preferences
Public gHomeAdv As Boolean               ' Whether home advantage is applicable
Public gDate() As String                 ' Date of meeting
Public gCompVenue() As String            ' Venue of meeting
Public gCompTitle() As String            ' Title of meeting
Public gRdrName() As String              ' Rider names
Public gRdrAvge() As Single              ' Rider averages
Public gLineupNo() As Integer            ' Lineup membership
Public gRidingNo() As Integer            ' Riding positions within lineups
Public gRdrStatus() As Integer           ' Ranking of competitors based on average
Public gRdrRnk() As Integer              ' Ranking of competitors by score
Public gTmRnk() As Integer               ' Ranking of teams by score
Public gRaceRes() As String              ' Ride-by-ride results of competitors
Public gRideNum() As Integer             ' Number of rides taken by competitors
Public gActualRides() As Integer         ' Number of actual rides taken by competitors
Public gRacePts() As Integer             ' Total race points of competitors
Public gBonusPts() As Integer            ' Total bonus points of competitors
Public gAvlRides() As Integer            ' Remaining programmed rides of competitors
Public gRiding() As Integer              ' Determines whether riders are absent or injured
Public gNomRides() As Integer            ' Records nominated rides
Public gRdrRepRides() As Integer         ' Records replacement rides
Public gTacSubRides() As Integer         ' Records tactical substitute rides
Public gLastRide() As Integer            ' Records last race result of each rider

Public gTmName() As String               ' Team names
Public gTmScore() As Integer             ' Team scores
Public gAddPts() As Integer              ' Points to add to team scores
Public gTbrk() As Integer                ' Rider tiebreak details
Public gTmTbrk() As Integer              ' Team tiebreak details
Public gRdrRepFac() As Integer           ' Details of rider replacement facilities
Public gHtRef() As Integer               ' References programmed heats
Public gHtDetail() As Integer            ' Records heat results
Public gHtScore() As Integer             ' Records team scores by heat

Public gFinished As Integer              ' Control variable
Public gTitle As String                  ' Current meeting title
Public gHeat As Integer                  ' Current heat
Public gHeatTitle As String              ' Current heat title
Public gGate As Integer                  ' Current gate position being inspected
Public gScoring As Integer               ' Whether to record individual scores
Public gResUse As Integer                ' Current type of reserve usage
Public gHandicapUse As Integer           ' Whether handicaps should be used
Public gNomHighest As Integer            ' Determines highest averaged rider to use in nominated heats
Public gNomLowest As Integer             ' Determines lowest averaged rider to use in nominated heats
Public gTacMode As Integer               ' Whether Tactical Subs are currently allowed
Public gRdrRepMode As Integer            ' Whether Replacements are currently allowed
Public gHighRdrScore As Integer          ' Records highest rider score
Public gHighBnScore As Integer           ' Records highest bonus score
Public gHighTmScore As Integer           ' Records highest team score
Public gHighHtScore As Integer           ' Records highest heat score
Public gNumStarters As Integer           ' Number of riders in current heat
Public gSupportComp As Boolean           ' Enables support competition
Public gAddRdrs As Integer               ' Number of additional riders
Public gRunoff As Integer                ' Current runoff type
Public gSubRunoff As Integer             ' Current runoff type
Public gLineup() As Integer              ' Riders in current heat
Public gRideCode() As Integer            ' Status of riders in current heat
Public gRideSub() As Integer             ' Riders substituted in current heat
Public gRunoffInfo() As Integer          ' Runoff details
Public gScript() As String               ' Stores meeting script
Public gScriptPtr As Integer             ' Determines next line of script to parse
Public gLastScriptPtr As Integer         ' Line of script parsed last
Public gProgHeats As Integer             ' Records last programmed heat
Public gGateFactor As Integer            ' Starting gate factor
Public gMaxHtLen As Integer              ' Records longest line for Heat Details

' Global Constants
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const REG_SZ = 1
Public Const ERROR_SUCCESS = 0&
Public Const SYNCHRONIZE = &H100000
Public Const STANDARD_RIGHTS_READ = &H20000
Public Const STANDARD_RIGHTS_WRITE = &H20000
Public Const STANDARD_RIGHTS_EXECUTE = &H20000
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const STANDARD_RIGHTS_ALL = 2031616
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_CREATE_LINK = &H20
Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Public Const REG_DWORD = 4
Public Const REG_BINARY = 3
Public Const MIIM_TYPE = &H10
Public Const MFT_STRING = &H0&
Public Const RGB_STARTNEWCOLUMNWITHVERTBAR = &H20&

' Registry API Calls
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal HKEY As Long) As Long
Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal HKEY As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal HKEY As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal HKEY As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" (ByVal HKEY As Long, ByVal lpSubKey As String, ByVal lpValue As String, lpcbValue As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" (ByVal HKEY As Long, ByVal lpSubKey As String, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal HKEY As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal HKEY As Long, ByVal lpSubKey As String) As Long
Declare Function GetMenu Lib "user32" (ByVal hWnd As Long) As Long
Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Declare Function GetMenuItemInfo Lib "user32" Alias "GetMenuItemInfoA" (ByVal hMenu As Long, ByVal un As Long, ByVal b As Boolean, lpmii As MENUITEMINFO) As Long
Declare Function SetMenuItemInfo Lib "user32" Alias "SetMenuItemInfoA" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Long, lpmii As MENUITEMINFO) As Long

Public Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As String
    cch As Long
End Type

Option Explicit

Public Sub Parse(Source As String, Separator As String, Field() As String, NumFields As Integer)
  
    Dim FieldID As Integer               ' Identifies parsed fields
    ReDim Field(NumFields)
  
    Do While Len(Source) > 0 And FieldID <> NumFields
        FieldID = FieldID + 1
        Source = CStr(Source)
        If InStr(1, Source, Separator) = 0 Then
            Field(FieldID) = Trim(Source)
            Source = ""
        Else
            Field(FieldID) = Trim(Left(Source, InStr(1, Source, Separator) - 1))
            Source = Mid(Source, InStr(1, Source, Separator) + Len(Separator))
        End If
    Loop
  
End Sub

Public Sub Main()
    
    Dim Temp As String                      ' Temporary variable
    ReDim Field(0) As String                ' Used to parse command line
    
    Randomize Timer
    
    ' Sets program version variable
    gVersion = Format(App.Major) + "." + Format(App.Minor)
    
    ' Sets default directory
    ChDir App.Path
    
    ' Calls procedure to read initialisation information
    GetSettings
    
    ' Sets Help File
    App.HelpFile = App.Path + "\" + "Speedway.hlp"
    frmMainWin.CommonDialog.HelpFile = App.HelpFile
    frmMainWin.CommonDialog.HelpCommand = cdlHelpContext
    
    ' Checks command line for filenames
    Temp = Command
    Parse Temp, " ", Field(), 1
    gAutoload = Field(1)
    
    Select Case UCase(Right(gAutoload, 4))
        Case ".MTG"
            gIniProc = 1
    '    Case ".RDB"
    '        gIniProc = 2
    End Select
    
    ' Displays forms
    frmMainWin.Show
    If gIniProc = 0 Then frmAbout.Show vbModal
    
End Sub

Public Sub RunMeeting()

    Dim Temp As String                  ' Temporary variable
    Dim TrackRes As Integer             ' Temporary variable
    Dim a As Integer                    ' Counter variable
    ReDim Field(0) As String            ' Used to parse meeting configuration file
    
    ' Parses control statements and heat lineups
    Do
        
        If gRunoff > 0 Then
            Runoffs
        Else
            Temp = gScript(gScriptPtr)
            Parse Temp, "-", Field(), 2
    
            Select Case UCase(Field(1))
                Case "SUPPORT"
                    Select Case Val(Field(2))
                        Case 1 To 8
                            If gResType = 2 Then TrackRes = gNumRes
                            If Val(Field(2)) <= 40 - (gNumGroups * gNumRiders + TrackRes) Then
                                gAddRdrs = Val(Field(2))
                            End If
                    End Select
                    If gProgHeats = 0 Then gProgHeats = gHeat
                    gSupportComp = True
                    gMinRides = 0
                    gFinished = 3
                    DisplayResults
                Case "HANDICAP"
                    Select Case UCase(Field(2))
                        Case "OFF"
                            gHandicapUse = 0
                        Case "ON"
                            gHandicapUse = 1
                        Case "RESET"
                            ReDim gLastRide(40)
                    End Select
                Case "NOMINATED"
                    Temp = Field(2)
                    Parse Temp, ",", Field(), 2
                    Select Case Val(Field(1))
                        Case 1 To gNumRiders - gTeamRes
                            gNomHighest = Val(Field(1))
                        Case Else
                            gNomHighest = 1
                    End Select
                    Select Case Val(Field(2))
                        Case 1 To gNumRiders - gTeamRes - gNomHighest + 1
                            gNomLowest = gNomHighest + Val(Field(2)) - 1
                        Case Else
                            gNomLowest = gNumRiders - gTeamRes
                    End Select
                    ReDim gNomRides(40)
                Case "POINTS"
                    Temp = Field(2)
                    Parse Temp, ",", Field(), 8
                    For a = 1 To 8
                        gHeatCode(a + 8) = Left(Field(a), 2)
                    Next a
                Case "RANKRIDERSCORES"
                    RankRiderScores
                Case "RANKTEAMSCORES"
                    RankTeamScores
                Case "RESERVES"
                    Select Case UCase(Field(2))
                        Case "OFF"
                            gResUse = 7
                        Case "ON"
                            gResUse = gResEnable
                    End Select
                Case "RDRREP"
                    Select Case UCase(Field(2))
                        Case "OFF"
                            gRdrRepMode = 0
                        Case "ON"
                            gRdrRepMode = 1
                    End Select
                Case "RUNOFFS"
                    If gRunoffUse > 1 Then
                        If gNumTeams <> 1 Or gNumGroups = 1 Then
                            Select Case Val(Field(2))
                                Case 2 To 8
                                    gNumStarters = Val(Field(2))
                                Case Else
                                    gNumStarters = 4
                            End Select
                            DetermineRunoffs
                        End If
                    End If
                Case "SCORING"
                    Select Case UCase(Field(2))
                        Case "OFF"
                            gScoring = 0
                        Case "ON"
                            gScoring = 1
                        Case "OPTIONAL"
                            If gSpclRaces = 2 Then
                                gScoring = 0
                            Else
                                gScoring = 1
                            End If
                    End Select
                Case "STARTPOS"
                    Select Case UCase(Field(2))
                        Case "FIXED"
                            gGateFactor = gStartPrefs
                        Case "PREF"
                            If gStartPrefs = 0 Then
                                gGateFactor = 0
                            Else
                                gGateFactor = 1
                            End If
                    End Select
                Case "TACSUBS"
                    Select Case UCase(Field(2))
                        Case "OFF"
                            gTacMode = 0
                        Case "ON"
                            gTacMode = 1
                        Case "UNRES"
                            gTacMode = 2
                    End Select
                Case "TFRRIDER"
                    TransferRider Field(2)
                Case "TFRTEAM"
                    If gNumTeams > 1 Then TransferTeam Field(2)
                Case Else
                    CreateRaceLineup
            End Select
        
        End If
        
        ' Detects end of script or maximum number of heats
        If gRunoff > 0 And gFinished = 1 Then
            DisplayResults
            Exit Do
        ElseIf gHeat = 40 Or gScriptPtr = UBound(gScript) Then
            If gFinished <> 2 Then
                If gProgHeats = 0 Then gProgHeats = gHeat
                gFinished = 3
                gSupportComp = False
                DisplayResults
            End If
        ElseIf gFinished = 1 Then
            DisplayResults
            gScriptPtr = gScriptPtr + 1
        ElseIf gFinished <> 2 Then
            gScriptPtr = gScriptPtr + 1
        End If
            
    Loop Until gFinished > 1
    
End Sub

Public Sub ReadScript(Index)

    Dim WorkingDir As String            ' Stores working directory
    Dim Temp As String                  ' Used to temporarily store file input
    Dim SupportComp As Integer          ' Check variable
    Dim a As Integer                    ' Counter variable
    Dim b As Integer                    ' Counter variable
    ReDim Field(0) As String            ' Used to parse meeting configuration file
        
    ' Error trap
    On Error GoTo ErrorHandler
      
    ' Changes to application directory
    WorkingDir = CurDir
    ChDir App.Path + "\Scripts"
    
    ' Opens meeting configuration file
    Open frmMainWin.mnuFNComp(Index).Tag For Input As #1
    
    ' Reads script into memory
    Do
        Line Input #1, Temp
        If Temp <> "" And Left(Trim(Temp), 1) <> "#" Then
            a = a + 1
            ReDim Preserve gScript(a)
            gScript(a) = Trim(Temp)
        End If
    Loop Until EOF(1)
  
    Close #1
    
    ' Parses script for meeting configuration values
    For a = 1 To UBound(gScript)
        Temp = gScript(a)
        Parse Temp, "=", Field(), 2
        Select Case UCase(Field(1))
            Case "NUMTEAMS"
                Temp = Field(2)
                Parse Temp, ",", Field(), 2
                gNumTeams = Val(Field(1))
                gDisplayGrps = Val(Field(2))
            Case "NUMGROUPS"
                Temp = Field(2)
                Parse Temp, ",", Field(), 2
                gNumGroups = Val(Field(1))
                gDisplayGrps = Val(Field(2))
            Case "NUMRIDERS"
                gNumRiders = Val(Field(2))
            Case "RESERVES"
                Temp = Field(2)
                Parse Temp, ",", Field(), 2
                gNumRes = Val(Field(1))
                gResType = Val(Field(2))
            Case "MAXRIDES"
                Temp = Field(2)
                Parse Temp, ",", Field(), 2
                Select Case Val(Field(1))
                    Case 0 To 9
                        gMaxRides = Val(Field(1))
                End Select
                Select Case Val(Field(2))
                    Case 0 To 9
                        gMaxResRides = Val(Field(2))
                End Select
            Case "MINRIDES"
                gMinRides = Val(Field(2))
            Case "RUNOFFS"
                gRunoffUse = Val(Field(2))
            Case "RESUSE"
                Select Case Val(Field(2))
                    Case 0 To 7
                        gResEnable = Val(Field(2))
                End Select
            Case "STARTPEN"
                Select Case Val(Field(2))
                    Case 0 To 99
                        gStartPen = Val(Field(2))
                End Select
            Case "BONUSPTS"
                gAddBonus = Val(Field(2))
            Case "TACSUBUSE"
                Temp = Field(2)
                Parse Temp, ",", Field(), 2
                gTacSubs = Val(Field(1))
                Select Case Val(Field(2))
                    Case 2 To 99
                        gTacEnable = Val(Field(2))
                    Case Else
                        gTacEnable = 6
                End Select
            Case "RDRREPUSE"
                Temp = Field(2)
                Parse Temp, ",", Field(), 2
                gRdrRep = Val(Field(1))
                gTeamRes = Val(Field(2))
            Case "SPCLRACES"
                Temp = Field(2)
                Parse Temp, ",", Field(), 2
                Select Case Val(Field(1))
                    Case 0 To 2
                        gSpclRaces = Val(Field(1))
                End Select
                gSpclTitle = Left(Field(2), 18)
            Case "GROUPTITLE"
                Temp = Field(2)
                Parse Temp, ",", Field(), 2
                Select Case Asc(Field(1))
                    Case 65 To 73
                        gTmName(Asc(Field(1)) - 64) = UCase(Left(Field(2), 32))
                End Select
            Case "HANDICAPUSE"
                Temp = Field(2)
                Parse Temp, ",", Field(), 8
                For b = 1 To 8
                    Select Case Val(Field(b))
                        Case 0 To 99
                            gHandicaps(b) = Val(Field(b))
                    End Select
                Next b
            Case "MAXAVERAGE"
                Select Case Val(Field(2))
                    Case 1 To 99
                        gMaxAvge = Val(Field(2))
                    Case Else
                        gMaxAvge = gDefMaxAvge
                End Select
            Case "COMPID"
                Temp = Field(2)
                Parse Temp, ",", Field(), 8
                For b = 1 To 8
                    gCompID(b) = UCase(Left(Field(b), 6))
                Next b
        End Select
    Next a
  
    ' Sets default meeting configuration values if necessary
    
    Select Case gNumTeams
        Case 2 To 9
            gNumGroups = gNumTeams
        Case Else
            gNumTeams = 1
            Select Case gNumGroups
                Case Is < 2, Is > 9
                    gNumGroups = 1
            End Select
    End Select
                
    Select Case gDisplayGrps
        Case Is < 2, Is > gNumGroups
            gDisplayGrps = gNumGroups
    End Select
            
    Select Case gNumRiders
        Case Is < 2, Is > 40
            gNumRiders = 2
        Case 9 To 40
            If gNumTeams > 1 Or gNumGroups > 1 Then gNumRiders = 2
        Case 7 To 8
            If gNumTeams > 4 Or gNumGroups > 4 Then gNumRiders = 2
        Case 5 To 6
            If gNumTeams > 6 Or gNumGroups > 6 Then gNumRiders = 2
        'Case 3 To 4
        '    If gNumTeams > 8 Or gNumGroups > 8 Then gNumRiders = 2
    End Select
      
    Select Case gNumRes
        Case Is < 0, Is > 4, Is > gNumRiders
            gNumRes = 0
    End Select
          
    If gNumTeams = 1 And gNumGroups >= 2 Then
        gResType = 2
    ElseIf gNumTeams = 1 And gResType = 1 Then
        gResType = 0
    ElseIf gResType < 0 Or gResType > 2 Then
        gResType = 0
    End If
    
    If gNumTeams = 1 Or gMinRides < 0 Or gMinRides > 9 Then
        gMinRides = 0
    End If
    
    If gNumTeams = 1 And gNumGroups >= 2 Then
        gRunoffUse = 0
    ElseIf gNumTeams = 1 And gNumRiders <= 4 Then
        Select Case gRunoffUse
            Case 2 To 4
                gRunoffUse = 3
            Case Is <> 1
                gRunoffUse = 0
        End Select
        gCheckPos = gNumRiders - 1
    ElseIf gNumTeams >= 2 And gNumTeams <= 4 Then
        Select Case gRunoffUse
            Case 2 To 4
                gRunoffUse = 3
            Case Is <> 1
                gRunoffUse = 0
        End Select
        gCheckPos = gNumTeams - 1
    Else
        Select Case gRunoffUse
            Case Is < 0, Is > 4
                gRunoffUse = 0
        End Select
        gCheckPos = 4
    End If
    
    If gNumTeams = 1 Or gScoringType = 1 Or gAddBonus < 0 Or gAddBonus > 2 Then
        gAddBonus = 0
    End If
    
    If gNumTeams = 1 Or gTacSubs < 0 Or gTacSubs > 2 Then
        gTacSubs = 0
    End If
    
    If gNumTeams = 1 Or gRdrRep < 0 Or gRdrRep > gNumRiders - 1 Then
        gRdrRep = 0
    End If
    
    If gTeamRes = 1 And gRdrRep > 0 And gNumTeams <= 4 Then
        gNumRiders = gNumRiders + 1
    Else
        gTeamRes = 0
    End If
        
    ' Parses script for programmed rides
    For a = 1 To UBound(gScript)
        Temp = gScript(a)
        Parse Temp, "-", Field(), 2
        Select Case UCase(Field(1))
            Case "SUPPORT"
                SupportComp = 1
            Case Else
                Temp = Field(1)
                Parse Temp, ":", Field(), 2
                If Field(2) <> "" And SupportComp = 0 Then
                    Temp = Field(2)
                    Parse Temp, ",", Field(), 8
                    For b = 1 To 8
                        If Field(b) <> "" Then
                            Select Case Asc(UCase(Left(Field(b), 1)))
                                Case 65 To gNumGroups + 64
                                    Select Case Val(Mid(Field(b), 2))
                                        Case 1 To gNumRiders
                                            gAvlRides(RiderID(Asc(UCase(Left(Field(b), 1))) - 64, Val(Mid(Field(b), 2)))) = gAvlRides(RiderID(Asc(UCase(Left(Field(b), 1))) - 64, Val(Mid(Field(b), 2)))) + 1
                                    End Select
                            End Select
                        End If
                    Next b
                End If
        End Select
    Next a
        
    ' Change back to working directory
    ChDir WorkingDir
    
    ' Displays Programme Editor
    gTitle = frmMainWin.mnuFNComp(Index).Caption
    frmProgEditor.Show vbModal

    Exit Sub
  
ErrorHandler:

    ChDir WorkingDir
    MsgBox "Configuration file not found", vbOKOnly + vbExclamation

End Sub

Public Sub ConfigMeeting(Index)

    Dim a As Integer                        ' Counter variable
    Dim b As Integer                        ' Counter variable
    
    ' Resets meeting configuration variables
    gNumTeams = 1: gNumGroups = 1: gDisplayGrps = 1: gNumRiders = 40
    gResType = 0: gNumRes = 0: gMinRides = 0: gMaxRides = 0
    gMaxResRides = 0: gResEnable = 0: gStartPen = 0: gRunoffUse = 0
    gTacSubs = 0: gTacEnable = 0: gRdrRep = 0: gTeamRes = 0
    gAddBonus = 0: gSpclRaces = 0: gSpclTitle = ""
    gMaxAvge = gDefMaxAvge: gScoringType = gDefScoringType
    gStartPrefs = gDefStartPrefs: gHomeAdv = gDefHomeAdv
    gCheckPos = 2: gSupportComp = False: gAddRdrs = 0: gProgHeats = 0
    gNumStarters = 4: gInteractive = 0
    ReDim gCompID(8), gScript(0)
    
    ReDim gDate(0), gCompVenue(0), gCompTitle(0), gControl(9)
    ReDim gRdrName(40), gRdrAvge(40), gRdrStatus(40), gLineupNo(40)
    ReDim gRidingNo(40), gRacePts(40), gBonusPts(40), gRideNum(40)
    ReDim gActualRides(40), gAvlRides(40), gRiding(40)
    ReDim gNomRides(40), gRdrRepRides(40), gTacSubRides(40)
    ReDim gLastRide(40), gTmName(9), gTmScore(9), gAddPts(9)
    ReDim gTbrk(40, 8), gTmTbrk(9, 8), gRdrRepFac(9, 2)
    ReDim gHeatCode(17), gHandicaps(8), gRunoffInfo(3, 2)
    ReDim gHtRef(40), gHtDetail(40, 8, 3), gHtScore(40, 4)
        
    ' Configures menu options
    frmMainWin.mnuMSuspend.Enabled = False
    frmMainWin.mnuMSep.Visible = False
    frmMainWin.mnuMScratch.Visible = False
    frmMainWin.mnuMSupport.Visible = False
    frmMainWin.mnuMContinue.Visible = False
    
    ' Configures and displays Programme Editor
    If Index = 0 Then
        gInteractive = 2
        gTitle = "Scratch Racing"
        frmProgEditor.Show vbModal
    Else
        ReadScript Index
    End If
    
    If gFinished = True Then
  
        ' Resets ride-by-ride results
        ReDim gRaceRes(40, gMaxRides)
    
        ' Resets rankings and determines absent riders
        ReDim gTmRnk(9), gRdrRnk(40)
        For a = 1 To 9
            gTmRnk(a) = a
        Next a
        For a = 1 To 40
            gRdrRnk(a) = a
            If gRdrName(a) <> "" And gRdrAvge(a) = 0 Then
                gRiding(a) = 1
            End If
        Next a
    
        ' Resets control variables
        gScriptPtr = 1
        gMaxHtLen = 30
        gHeat = 0
        gScoring = 1
        gResUse = gResEnable
        gNomHighest = 1
        gNomLowest = gNumRiders - gTeamRes
        gTacMode = 0
        If gRdrRep > 0 Then
            gRdrRepMode = 1
        Else
            gRdrRepMode = 0
        End If
        gHandicapUse = 1
        gRunoff = 0
        gHighTmScore = 0
        gHighHtScore = 0
        gHighRdrScore = 0
        gHighBnScore = 0
    
        ' Adds home advantage to rider averages
        If gNumTeams > 1 And gHomeAdv = True Then
            For a = 1 To gNumRiders
                gRdrAvge(a) = gRdrAvge(a) * 1.05
            Next a
        End If
        
        ' Defines starting gate preferences
        Select Case gStartPrefs
            Case 0
                gStartPrefs = Int(Rnd * 2 + 1)
            Case 3
                gStartPrefs = 0
        End Select
        gGateFactor = gStartPrefs
        
        ' Defines Programme Marking symbols
        For a = 1 To 17
            If gHeatCode(a) = "" Then
                gHeatCode(a) = gDefHeatCode(a)
            End If
        Next
        
        frmMainWin.mnuMSep.Visible = True
        Select Case gInteractive
            Case 0
                frmMainWin.mnuMScratch.Visible = True
                frmMainWin.mnuMSupport.Visible = False
                frmMainWin.mnuMContinue.Visible = False
                RankAverages
                RunMeeting
            Case 1
                frmMainWin.mnuMScratch.Visible = False
                frmMainWin.mnuMSupport.Visible = False
                frmMainWin.mnuMContinue.Visible = True
                RankAverages
                RunMeeting
            Case 2
                frmMainWin.mnuMScratch.Visible = False
                frmMainWin.mnuMSupport.Visible = False
                frmMainWin.mnuMContinue.Visible = True
                ScratchRacing
        End Select
        
    End If

End Sub

Public Sub CreateRaceLineup()

    Dim Temp As String              ' Temporary variable
    Dim a As Integer                ' Counter variable
    Dim b As Integer                ' Counter variable
    ReDim HeatData(0) As String     ' Used to parse line-up data
    ReDim RdrData(0) As String      ' Used to parse line-up data
    ReDim AddData(0) As String      ' Used to parse line-up data
  
    ' Checks for heat data
    Temp = gScript(gScriptPtr)
    Parse Temp, ":", HeatData(), 2
    
    If HeatData(2) <> "" Then
        
        ' Reinitialises heat configuration
        ReDim gLineup(8, 5), gRideCode(40), gRideSub(40)
        gNumStarters = 0
        gHeatTitle = ""
        
        ' Configures heat title
        If Val(HeatData(1)) <> gHeat + 1 Then
            gHeatTitle = Left(HeatData(1), 20)
        End If
        
        ' Parses heat data
        Temp = HeatData(2)
        Parse Temp, ",", HeatData(), 8
        
        For a = 1 To 8
            If HeatData(a) <> "" Then
            
                Parse HeatData(a), "@", RdrData(), 2
                
                ' Adds specified rider to line-up
                Select Case Asc(UCase(Left(RdrData(1), 1)))
                    Case 65 To gNumGroups + 64          ' Teams A to I
                        Select Case UCase(Mid(RdrData(1), 2, 1))
                            Case "N"
                                Select Case Val(Mid(RdrData(1), 3))
                                    Case 1 To gNumRiders
                                        gNumStarters = gNumStarters + 1
                                        gLineup(gNumStarters, 1) = gRdrRnk(RiderID(Asc(UCase(Left(RdrData(1), 1))) - 64, Val(Mid(RdrData(1), 3))))
                                        gLineup(gNumStarters, 3) = gNomHighest
                                End Select
                            Case "R"
                                Select Case Val(Mid(RdrData(1), 3))
                                    Case 1 To gNumRiders
                                        gNumStarters = gNumStarters + 1
                                        gLineup(gNumStarters, 1) = gRdrStatus(RiderID(Asc(UCase(Left(RdrData(1), 1))) - 64, Val(Mid(RdrData(1), 3))))
                                End Select
                            Case "S"
                                Select Case Val(Mid(RdrData(1), 3))
                                    Case 1 To gNumRiders
                                        gNumStarters = gNumStarters + 1
                                        gLineup(gNumStarters, 1) = gRdrRnk(RiderID(Asc(UCase(Left(RdrData(1), 1))) - 64, Val(Mid(RdrData(1), 3))))
                                End Select
                            Case "T"
                                Select Case Val(Mid(RdrData(1), 3))
                                    Case 1 To gNumRiders
                                        gNumStarters = gNumStarters + 1
                                        gLineup(gNumStarters, 1) = gRdrRnk(RiderID(Asc(UCase(Left(RdrData(1), 1))) - 64, Val(Mid(RdrData(1), 3))))
                                        gLineup(gNumStarters, 2) = Val(Mid(RdrData(1), 3))
                                End Select
                            Case Else
                                Select Case Val(Mid(RdrData(1), 2))
                                    Case 1 To gNumRiders
                                        gNumStarters = gNumStarters + 1
                                        gLineup(gNumStarters, 1) = RiderID(Asc(UCase(Left(RdrData(1), 1))) - 64, Val(Mid(RdrData(1), 2)))
                                        If gScoring = 1 And gScriptPtr <> gLastScriptPtr Then
                                            gAvlRides(gLineup(gNumStarters, 1)) = gAvlRides(gLineup(gNumStarters, 1)) - 1
                                        End If
                                End Select
                        End Select
                    Case Is = 82                        ' R prefix
                        If gNumGroups = 1 Then
                            Select Case Val(Mid(RdrData(1), 2))
                                Case 0 To gNumRiders
                                    gNumStarters = gNumStarters + 1
                                    gLineup(gNumStarters, 1) = gRdrStatus(Val(Mid(RdrData(1), 2)))
                            End Select
                        End If
                    Case Is = 83                        ' S prefix
                        Select Case Asc(UCase(Mid(RdrData(1), 2, 1)))
                            Case 65 To gNumGroups + 64
                                Select Case UCase(Mid(RdrData(1), 3, 1))
                                    Case "N"
                                        Select Case Val(Mid(RdrData(1), 4))
                                            Case 1 To gNumRiders
                                                gNumStarters = gNumStarters + 1
                                                gLineup(gNumStarters, 1) = gRdrRnk(RiderID(gTmRnk(Asc(UCase(Mid(RdrData(1), 2, 1))) - 64), Val(Mid(RdrData(1), 4))))
                                                gLineup(gNumStarters, 3) = Val(Mid(RdrData(1), 4))
                                        End Select
                                    Case "R"
                                        Select Case Val(Mid(RdrData(1), 4))
                                            Case 1 To gNumRiders
                                                gNumStarters = gNumStarters + 1
                                                gLineup(gNumStarters, 1) = gRdrStatus(RiderID(gTmRnk(Asc(UCase(Mid(RdrData(1), 2, 1))) - 64), Val(Mid(RdrData(1), 4))))
                                        End Select
                                    Case "S"
                                        Select Case Val(Mid(RdrData(1), 4))
                                            Case 1 To gNumRiders
                                                gNumStarters = gNumStarters + 1
                                                gLineup(gNumStarters, 1) = gRdrRnk(RiderID(gTmRnk(Asc(UCase(Mid(RdrData(1), 2, 1))) - 64), Val(Mid(RdrData(1), 4))))
                                        End Select
                                    Case "T"
                                        Select Case Val(Mid(RdrData(1), 4))
                                            Case 1 To gNumRiders
                                                gNumStarters = gNumStarters + 1
                                                gLineup(gNumStarters, 1) = gRdrRnk(RiderID(gTmRnk(Asc(UCase(Mid(RdrData(1), 2, 1))) - 64), Val(Mid(RdrData(1), 4))))
                                                gLineup(gNumStarters, 2) = Val(Mid(RdrData(1), 4))
                                        End Select
                                    Case Else
                                        Select Case Val(Mid(RdrData(1), 3))
                                            Case 1 To gNumRiders
                                                gNumStarters = gNumStarters + 1
                                                gLineup(gNumStarters, 1) = RiderID(gTmRnk(Asc(UCase(Mid(RdrData(1), 2, 1))) - 64), Val(Mid(RdrData(1), 3)))
                                        End Select
                                End Select
                            Case Else
                                Parse Mid(RdrData(1), 2), ".", AddData(), 2
                                If Val(AddData(1)) > 0 And Val(AddData(2)) = 0 Then
                                    If gNumGroups = 1 And Val(AddData(1)) <= gNumRiders Then
                                        gNumStarters = gNumStarters + 1
                                        gLineup(gNumStarters, 1) = gRdrRnk(Val(AddData(1)))
                                    End If
                                ElseIf Val(AddData(1)) > 0 And Val(AddData(1)) <= 8 And Val(AddData(2)) <= gHtRef(0) Then
                                    gNumStarters = gNumStarters + 1
                                    gLineup(gNumStarters, 1) = gHtDetail(gHtRef(Val(AddData(2))), Val(AddData(1)), 1)
                                End If
                        End Select
                    Case Is = 84                        ' T prefix
                        Parse Mid(RdrData(1), 2), ".", AddData(), 2
                        If Val(AddData(1)) > 0 And Val(AddData(2)) = 0 Then
                            If gNumGroups = 1 And Val(AddData(1)) <= gNumRiders Then
                                gNumStarters = gNumStarters + 1
                                gLineup(gNumStarters, 1) = gRdrRnk(Val(AddData(1)))
                                gLineup(gNumStarters, 2) = Val(AddData(1))
                            End If
                        ElseIf Val(AddData(1)) > 0 And Val(AddData(1)) <= 8 And Val(AddData(2)) <= gHtRef(0) Then
                            gNumStarters = gNumStarters + 1
                            gLineup(gNumStarters, 1) = gHtDetail(gHtRef(Val(AddData(2))), Val(AddData(1)), 1)
                            gLineup(gNumStarters, 2) = Val(AddData(1))
                            gLineup(gNumStarters, 3) = gHtRef(Val(AddData(2)))
                        End If
                    Case Else                           ' Riders 1 to 40
                        If gNumGroups = 1 Then
                            Select Case Val(RdrData(1))
                                Case 0 To 40
                                    gNumStarters = gNumStarters + 1
                                    gLineup(gNumStarters, 1) = Val(RdrData(1))
                            End Select
                        Else
                            Select Case Val(RdrData(1))
                                Case 0 To 40 - gNumGroups * gNumRiders
                                    gNumStarters = gNumStarters + 1
                                    gLineup(gNumStarters, 1) = gNumGroups * gNumRiders + Val(RdrData(1))
                            End Select
                        End If
                End Select
                
                ' Adds default handicap if specified
                If Val(RdrData(2)) > 0 And Val(RdrData(2)) < 100 Then
                    gLineup(gNumStarters, 4) = Val(RdrData(2))
                End If
                gLineup(gNumStarters, 5) = Handicap(gLineup(gNumStarters, 1))
                      
                ' Checks selected rider is not already in heat
                If gNumStarters > 1 Then
                    b = 1
                    Do
                        If gLineup(a, 1) = gLineup(b, 1) Then
                            gLineup(a, 1) = 0
                        End If
                        b = b + 1
                    Loop Until gLineup(b, 1) = 0 Or b > gNumStarters - 1
                End If
                
            End If
        Next a
        
        ' Starts racing or allows user input
        If gFinished = 1 Then
            gFinished = 2
        Else
            If gNumStarters > 1 And gHeat < 40 Then
                RaceCalculation
            End If
        End If
    
    End If
    
    ' Records line of script being parsed
    gLastScriptPtr = gScriptPtr
    
End Sub

Public Sub DisplayResults()
  
    Dim Results As String               ' Holds compiled results
    Dim Reserves As Integer             ' Temporary variable
    Dim TrackRes As Integer             ' Temporary variable
    Dim Team As Integer                 ' Temporary variable
    Dim Rider As Integer                ' Temporary variable
    Dim NumRiders As Integer            ' Temporary variable
    Dim TempVal As Integer              ' Temporary variable
    Dim TempStr As String               ' Temporary variable
    Dim NotSort As Integer              ' Check variable
    Dim Comp1 As Integer                ' Comparison variable
    Dim Comp2 As Integer                ' Comparison variable
    Dim a As Integer                    ' Counter variable
    Dim b As Integer                    ' Counter variable
    Dim c As Integer                    ' Counter variable
    Dim TmRnk(9) As Integer             ' Ranking of teams by score
    Dim RdrRnk(40) As Integer           ' Ranking of competitors by score
        
    ' Sorts scorechart according to type of meeting
    For a = 1 To 9: TmRnk(a) = a: Next a
    For a = 1 To 40: RdrRnk(a) = a: Next a
    
    Select Case gNumTeams
        Case 1
            If gNumGroups = 1 And gResType = 2 Then
                Reserves = gNumRes
            End If
            For a = 1 To gNumGroups
                Do
                    NotSort = 0
                    For b = 1 To gNumRiders - Reserves - 1
                        Comp1 = gRacePts(RdrRnk(RiderID(a, b))) + gBonusPts(RdrRnk(RiderID(a, b)))
                        Comp2 = gRacePts(RdrRnk(RiderID(a, b + 1))) + gBonusPts(RdrRnk(RiderID(a, b + 1)))
                        If Comp1 < Comp2 Then
                            TempVal = RdrRnk(RiderID(a, b))
                            RdrRnk(RiderID(a, b)) = RdrRnk(RiderID(a, b + 1))
                            RdrRnk(RiderID(a, b + 1)) = TempVal
                            NotSort = 1
                        ElseIf Comp1 = Comp2 Then
                            For c = 0 To 8
                                Comp1 = gTbrk(RdrRnk(RiderID(a, b)), c)
                                Comp2 = gTbrk(RdrRnk(RiderID(a, b + 1)), c)
                                If Comp1 < Comp2 Then
                                    TempVal = RdrRnk(RiderID(a, b))
                                    RdrRnk(RiderID(a, b)) = RdrRnk(RiderID(a, b + 1))
                                    RdrRnk(RiderID(a, b + 1)) = TempVal
                                    NotSort = 1
                                    Exit For
                                ElseIf Comp1 > Comp2 Then
                                    Exit For
                                End If
                            Next c
                        End If
                    Next b
                Loop Until NotSort = 0
            Next a
        Case Is > 2
            Do
                NotSort = 0
                For a = 1 To gNumTeams - 1
                    If gTmScore(TmRnk(a)) < gTmScore(TmRnk(a + 1)) Then
                        TempVal = TmRnk(a)
                        TmRnk(a) = TmRnk(a + 1)
                        TmRnk(a + 1) = TempVal
                        NotSort = 1
                    ElseIf gTmScore(TmRnk(a)) = gTmScore(TmRnk(a + 1)) Then
                        For b = 0 To 8
                            If gTmTbrk(TmRnk(a), b) < gTmTbrk(TmRnk(a + 1), b) Then
                                TempVal = TmRnk(a)
                                TmRnk(a) = TmRnk(a + 1)
                                TmRnk(a + 1) = TempVal
                                NotSort = 1
                                Exit For
                            ElseIf gTmTbrk(TmRnk(a), b) > gTmTbrk(TmRnk(a + 1), b) Then
                                Exit For
                            End If
                        Next b
                    End If
                Next a
            Loop Until NotSort = 0
    End Select

    ' Compiles meeting details
    If gDate(0) <> "" Then
        Results = Space(1) + gDate(0)
        If gCompVenue(0) <> "" Then
            Results = Results + Space(2) + "at " + gCompVenue(0)
        End If
        Results = Results + Chr(13) + Chr(10)
        If gCompTitle(0) <> "" Then
            Results = Results + Space(1) + gCompTitle(0) + Chr(13) + Chr(10)
        End If
        Results = Results + Chr(13) + Chr(10)
    End If
    
    If gNumGroups > 1 And gResType = 2 Then TrackRes = gNumRes

    ' Compiles scorechart by team
    If gMaxRides > 0 Then
        
        For a = 1 To gNumGroups + Sgn(TrackRes)
        
            If a > gNumGroups Then
                Team = 0
                NumRiders = TrackRes
            Else
                Team = TmRnk(a)
                NumRiders = gNumRiders
            End If

            If gNumTeams = 1 And gNumGroups >= 2 And a <= gNumGroups Then
                Results = Results + Space(1) + gTmName(a) + Space(1)
                Results = Results + Chr(13) + Chr(10)
            ElseIf gTmName(Team) <> "" Then
                Results = Results + Space(1) + gTmName(Team) + Space(1)
                Results = Results + Format(gTmScore(Team))
                If gAddPts(Team) > 0 Then
                    Results = Results + Space(1) + "(" + Format(gTmScore(Team) + gAddPts(Team)) + ")"
                End If
                Results = Results + Chr(13) + Chr(10)
            End If

            For b = 1 To NumRiders
            
                If a > gNumGroups Then
                    Rider = gNumGroups * gNumRiders + b
                Else
                    Rider = RdrRnk(RiderID(Team, b))
                End If

                If gNumGroups = 1 And gResType = 2 And b > gNumRiders - gNumRes Then
                    If gRdrName(Rider) <> "" Then
                        Results = Results + Space(Len(Str(Trim(gNumRiders))) - 1) + "R. "
                    End If
                ElseIf a > gNumGroups Then
                    If gRdrName(Rider) <> "" Then
                        Results = Results + " R. "
                    Else
                        TrackRes = TrackRes - 1
                    End If
                ElseIf gTeamRes = 0 Or b <> NumRiders Or gRdrName(Rider) <> "" Then
                    Results = Results + Space(Len(Format(gNumRiders)) - Len(Format(b)) + 1) + Format(b) + ". "
                    If gRdrName(Rider) = "" Then
                        Results = Results + Chr(13) + Chr(10)
                    End If
                End If

                If gRdrName(Rider) <> "" Then
                    Results = Results + gRdrName(Rider)
                    Results = Results + String(26 - Len(gRdrName(Rider)), ".") + Space(1)
                    If Rider = gRdrRepFac(Team, 1) Then
                        Results = Results + "Rider replacement"
                    ElseIf gProgHeats > 0 And gRideNum(Rider) = 0 Then
                        Results = Results + "Did not ride"
                    Else
                        For c = 1 To gMaxRides
                            If gRaceRes(Rider, c) = "" Then
                                TempStr = "-"
                            Else
                                TempStr = gRaceRes(Rider, c)
                            End If
                            Results = Results + TempStr + Space(3 - Len(TempStr))
                        Next c
                        If gHighRdrScore > 99 Then
                            TempStr = Space(Len(Format(gHighRdrScore)) - Len(Format(gRacePts(Rider)))) + Format(gRacePts(Rider))
                        Else
                            TempStr = Space(2 - Len(Format(gRacePts(Rider)))) + Format(gRacePts(Rider))
                        End If
                        Results = Results + TempStr
                        If gBonusPts(Rider) > 0 Then
                            Results = Results + Format(gBonusPts(Rider), "+#")
                        End If
                        If gRiding(Rider) > 0 Then
                            If gHighBnScore > 0 And gBonusPts(Rider) > 0 Then
                                TempStr = Space(Len(Format(gHighBnScore)) - Len(Format(gBonusPts(Rider))) + 1)
                            ElseIf gHighBnScore > 0 Then
                                TempStr = Space(Len(Format(gHighBnScore)) + 2)
                            Else
                                TempStr = Space(1)
                            End If
                            Select Case gRiding(Rider)
                                Case 1
                                    Results = Results + TempStr + "(A)"
                                Case 2
                                    Results = Results + TempStr + "(I)"
                            End Select
                        End If
                    End If
                    Results = Results + Chr(13) + Chr(10)
                End If
              
            Next b
        
            If a <= gNumGroups Or TrackRes > 0 Then
                Results = Results + Chr(13) + Chr(10)
            End If
        
        Next a
    
    End If
    
    ' Compiles header for heat details
    Select Case gNumTeams
        Case 1, 5 To 9
            Results = Results + " No. Results" + Chr(13) + Chr(10)
        Case 2 To 4
            Results = Results + " No. Results" + Space(gMaxHtLen - 7)
            If gNumTeams = 2 Then
                For a = 1 To 2
                    If gHighTmScore > 99 Then
                        Results = Results + Space(Len(Format(gHighTmScore)) - 2 + 1)
                    Else
                        Results = Results + Space(1)
                    End If
                    If Len(gTmName(a)) < 2 Then
                        Results = Results + "T" + Format(a, "#")
                    Else
                        Results = Results + Left(gTmName(a), 2)
                    End If
                Next a
                Results = Results + Space(1)
            End If
            For a = 1 To gNumTeams
                If gHighTmScore > 99 Then
                    Results = Results + Space(Len(Format(gHighTmScore)) - 2 + 1)
                Else
                    Results = Results + Space(1)
                End If
                If Len(gTmName(a)) < 2 Then
                    Results = Results + "T" + Format(a, "#")
                Else
                    Results = Results + Left(gTmName(a), 2)
                End If
            Next a
            Results = Results + Chr(13) + Chr(10)
    End Select

    ' Compiles heat details
    For a = 1 To gHeat
        If a = gProgHeats + 1 And gProgHeats > 0 Then
            Results = Results + Chr(13) + Chr(10)
        End If
        Results = Results + Space(3 - Len(Format(a))) + Format(a) + ": "
        If gHtDetail(a, 0, 1) = 0 Then
            Results = Results + "Race not held"
        Else
            For b = 1 To 8
                If gRdrName(gHtDetail(a, b, 1)) <> "" Then
                    If b > 1 Then Results = Results + ", "
                    Results = Results + gRdrName(gHtDetail(a, b, 1))
                    If gHtDetail(a, b, 2) < 9 And gHtDetail(a, b, 3) > 0 Then
                        Results = Results + Space(1) + "(" + Format(gHtDetail(a, b, 3), "0") + "/" + gHeatCode(gHtDetail(a, b, 2)) + ")"
                    ElseIf gHtDetail(a, b, 2) < 9 Then
                        Results = Results + Space(1) + "(" + gHeatCode(gHtDetail(a, b, 2)) + ")"
                    ElseIf gHtDetail(a, b, 3) > 0 Then
                        Results = Results + Space(1) + "(" + Format(gHtDetail(a, b, 3), "0") + ")"
                    End If
                End If
            Next b
        End If
        If gNumTeams >= 2 And gNumTeams <= 4 And gHtScore(a, 0) = 0 Then
            If gHtDetail(a, 0, 1) = 0 Then
                Results = Results + String(gMaxHtLen - 13, ".")
            Else
                Results = Results + String(gMaxHtLen - gHtDetail(a, 0, 1) + 2, ".")
            End If
            If gNumTeams = 2 Then
                For c = 1 To 2
                    If gHighHtScore > 99 Then
                        TempStr = Space(Len(Format(gHighHtScore)) - Len(Format(gHtScore(a, c + 2))) + 1) + Format(gHtScore(a, c + 2))
                    Else
                        TempStr = Space(3 - Len(Format(gHtScore(a, c + 2)))) + Format(gHtScore(a, c + 2))
                    End If
                    Results = Results + TempStr
                Next c
                Results = Results + Space(1)
            End If
            For c = 1 To gNumTeams
                If gHighTmScore > 99 Then
                    TempStr = Space(Len(Format(gHighTmScore)) - Len(Format(gHtScore(a, c))) + 1) + Format(gHtScore(a, c))
                Else
                    TempStr = Space(3 - Len(Format(gHtScore(a, c)))) + Format(gHtScore(a, c))
                End If
                Results = Results + TempStr
            Next c
        End If
        Results = Results + Space(1) + Chr(13) + Chr(10)
    Next a

    ' Updates results window
    frmMainWin.txtResults.Enabled = True
    frmMainWin.txtResults.Text = Results
    
    UpdateMenus
  
End Sub

Public Sub RaceCalculation()

    Dim Rerun As Integer                ' Whether race is being re-run
    Dim Start As Integer                ' Stores start condition
    Dim Lap As Integer                  ' Current lap
    Dim Rdr As Integer                  ' Current rider
    Dim Rndm As Single                  ' Temporary variable
    Dim Exclusion As Integer            ' Temporary variable
    Dim Temp As String                  ' Temporary variable
    Dim a As Integer                    ' Counter variable
    Dim b As Integer                    ' Counter variable
    
    If gInteractive > 0 Then
        gGate = 0
        frmHeatMgr.Show vbModal
        If gFinished = 2 Then Exit Sub
    End If
    
    If gTacSubs = 2 And gTacMode > 0 Then TacticalSubs
  
    ' Runs race
    Do
        Rerun = 0
        
        ' Resets race variables
        ReDim Score(1 To gNumStarters) As Single
        ReDim Position(1 To gNumStarters) As Integer
        
        ' Starting procedure
        For gGate = 1 To gNumStarters
  
            If gControl(gLineupNo(gLineup(gGate, 1))) = 0 And gInteractive <> 2 Then
                If gRdrRepMode = 1 Then Replacements
            End If

            If gRdrAvge(gLineup(gGate, 1)) = 0 Then
                Select Case gRideCode(gLineup(gGate, 1))
                    Case 0
                        gRideCode(gLineup(gGate, 1)) = 1
                        If gControl(gLineupNo(gLineup(gGate, 1))) = 0 And gInteractive <> 2 Then
                            Select Case gResUse
                                Case 0, 1, 4, 5
                                    ReserveSubs
                            End Select
                        End If
                    Case 2
                        Select Case gResUse
                            Case 0, 1, 4, 5
                                If gControl(gLineupNo(gLineup(gGate, 1))) = 1 Or gInteractive = 2 Then
                                    frmHeatMgr.Show vbModal, frmMainWin
                                Else
                                    ReserveSubs
                                End If
                        End Select
                End Select
            ElseIf gRideCode(gLineup(gGate, 1)) = 0 Or gRideCode(gLineup(gGate, 1)) = 9 Then
                Start = Int(Rnd * 403 + 3)
                Select Case Start
                    Case 3
                        gRideCode(gLineup(gGate, 1)) = Start
                        Select Case gResUse
                            Case 0, 2, 4, 6
                                If gControl(gLineupNo(gLineup(gGate, 1))) = 1 Or gInteractive = 2 Then
                                    frmHeatMgr.Show vbModal, frmMainWin
                                Else
                                    ReserveSubs
                                End If
                        End Select
                    Case 4
                        If gStartPen > 0 Then
                            gLineup(gGate, 5) = gLineup(gGate, 5) + gStartPen
                            Select Case gResUse
                                Case 0, 3, 5, 6
                                    If gControl(gLineupNo(gLineup(gGate, 1))) = 1 Or gInteractive = 2 Then
                                        frmHeatMgr.Show vbModal, frmMainWin
                                    Else
                                        gGate = gGate - 1
                                    End If
                                Case Else
                                    gGate = gGate - 1
                            End Select
                        Else
                            gRideCode(gLineup(gGate, 1)) = Start
                            Select Case gResUse
                                Case 0, 3, 5, 6
                                    If gControl(gLineupNo(gLineup(gGate, 1))) = 1 Or gInteractive = 2 Then
                                        frmHeatMgr.Show vbModal, frmMainWin
                                    Else
                                        ReserveSubs
                                    End If
                            End Select
                        End If
                    Case Else
                        gRideCode(gLineup(gGate, 1)) = 9
                        Score(gGate) = (Score(gGate) - gLineup(gGate, 4) - gLineup(gGate, 5)) * 0.005
                        If gGateFactor = 1 And gGate <= gNumStarters / 2 Then
                            Score(gGate) = Score(gGate) + 0.125
                        ElseIf gGateFactor = 2 And gGate > gNumStarters / 2 Then
                            Score(gGate) = Score(gGate) + 0.125
                        End If
                End Select
            End If
  
        Next gGate
        
        ' Runs race proper
        Lap = 1
        Do
            Rdr = 1
            Do
                If gRideCode(gLineup(Rdr, 1)) = 9 Then
                    Rndm = Rnd * gRdrAvge(gLineup(Rdr, 1))
                    Select Case Rndm
                        Case Is < gRdrAvge(gLineup(Rdr, 1)) * 0.00375
                            gRideCode(gLineup(Rdr, 1)) = 5
                        Case gRdrAvge(gLineup(Rdr, 1)) * 0.00375 To gRdrAvge(gLineup(Rdr, 1)) * 0.00375 + 0.00375
                            Exclusion = Int(Rnd * 100 + 1)
                            Select Case Exclusion
                                Case Is <= 40
                                    gRideCode(gLineup(Rdr, 1)) = 6
                                Case 41 To 85
                                    gRideCode(gLineup(Rdr, 1)) = 7
                                    If Lap < 4 Then Rerun = 1
                                Case Else
                                    gRideCode(gLineup(Rdr, 1)) = 8
                                    If Lap < 4 Then Rerun = 1
                            End Select
                            Injuries Score(), Rdr, Lap
                        Case Else
                            Score(Rdr) = Score(Rdr) + Rndm
                    End Select
                End If
                Rdr = Rdr + 1
            Loop Until Rdr > gNumStarters Or Rerun = 1
            Lap = Lap + 1
        Loop Until Lap > 4 Or Rerun = 1
    
    Loop While Rerun = 1

    ' Increments heat number
    gHeat = gHeat + 1
    
    ' References heat
    If gRunoff = 0 And gInteractive <> 2 Then
        gHtRef(0) = gHtRef(0) + 1
        gHtRef(gHtRef(0)) = gHeat
    End If

    ' Produces heat result
    For a = 1 To gNumStarters

        ' Determines heat placing and points awarded
        If a <> gNumStarters Then
            For b = a + 1 To gNumStarters
                If Score(a) >= Score(b) And gRideCode(gLineup(a, 1)) >= 9 Then
                    If gScoringType = 0 Or gNumTeams = 1 Or gLineupNo(gLineup(a, 1)) <> gLineupNo(gLineup(b, 1)) Then
                        gRideCode(gLineup(a, 1)) = gRideCode(gLineup(a, 1)) + 1
                    End If
                    Position(b) = Position(b) + 1
                ElseIf Score(a) < Score(b) And gRideCode(gLineup(b, 1)) >= 9 Then
                    If gScoringType = 0 Or gNumTeams = 1 Or gLineupNo(gLineup(a, 1)) <> gLineupNo(gLineup(b, 1)) Then
                        gRideCode(gLineup(b, 1)) = gRideCode(gLineup(b, 1)) + 1
                    End If
                    Position(a) = Position(a) + 1
                ElseIf gRideCode(gLineup(a, 1)) >= 9 Then
                    If gScoringType = 0 Or gNumTeams = 1 Or gLineupNo(gLineup(a, 1)) <> gLineupNo(gLineup(b, 1)) Then
                        gRideCode(gLineup(a, 1)) = gRideCode(gLineup(a, 1)) + 1
                    End If
                    Position(b) = Position(b) + 1
                ElseIf gRideCode(gLineup(b, 1)) >= 9 Then
                    If gScoringType = 0 Or gNumTeams = 1 Or gLineupNo(gLineup(a, 1)) <> gLineupNo(gLineup(b, 1)) Then
                        gRideCode(gLineup(b, 1)) = gRideCode(gLineup(b, 1)) + 1
                    End If
                    Position(a) = Position(a) + 1
                ElseIf gRideCode(gLineup(a, 1)) <> 2 And gRideCode(gLineup(b, 1)) = 2 Then
                    Position(a) = Position(a) + 1
                ElseIf gRideCode(gLineup(a, 1)) < 5 And gRideCode(gLineup(b, 1)) >= 5 Then
                    Position(a) = Position(a) + 1
                ElseIf gRideCode(gLineup(a, 1)) = 1 And gRideCode(gLineup(b, 1)) <> 1 Then
                    Position(a) = Position(a) + 1
                ElseIf gRdrName(gLineup(a, 1)) = "" And gRdrName(gLineup(b, 1)) <> "" Then
                    Position(a) = Position(a) + 1
                Else
                    Position(b) = Position(b) + 1
                End If
            Next b
        End If
        
        ' Updates last ride details
        gLastRide(gLineup(a, 1)) = gRideCode(gLineup(a, 1))
        
        ' Writes heat details
        gHtDetail(gHeat, Position(a) + 1, 1) = gLineup(a, 1)
        gHtDetail(gHeat, Position(a) + 1, 2) = gRideCode(gLineup(a, 1))
        gHtDetail(gHeat, Position(a) + 1, 3) = gLineup(a, 4) + gLineup(a, 5)

        If gRdrName(gHtDetail(gHeat, Position(a) + 1, 1)) <> "" Then
            gHtDetail(gHeat, 0, 1) = gHtDetail(gHeat, 0, 1) + Len(gRdrName(gHtDetail(gHeat, Position(a) + 1, 1))) + 2
            If gHtDetail(gHeat, Position(a) + 1, 2) < 9 And gHtDetail(gHeat, Position(a) + 1, 3) > 0 Then
                gHtDetail(gHeat, 0, 1) = gHtDetail(gHeat, 0, 1) + Len(gHeatCode(gHtDetail(gHeat, Position(a) + 1, 2))) + Len(Format(gHtDetail(gHeat, Position(a) + 1, 3))) + 4
            ElseIf gHtDetail(gHeat, Position(a) + 1, 2) < 9 Then
                gHtDetail(gHeat, 0, 1) = gHtDetail(gHeat, 0, 1) + Len(gHeatCode(gHtDetail(gHeat, Position(a) + 1, 2))) + 3
            ElseIf gHtDetail(gHeat, Position(a) + 1, 3) > 0 Then
                gHtDetail(gHeat, 0, 1) = gHtDetail(gHeat, 0, 1) + Len(Format(gHtDetail(gHeat, Position(a) + 1, 3))) + 3
            End If
            gHtDetail(gHeat, 0, 2) = gHtDetail(gHeat, 0, 2) + 1
        End If
                
    Next a
    
    If gScoring = 1 Then
        
        For Rdr = 1 To 40
            If gRideCode(Rdr) > 0 Then
                
                ' Updates rider statistics
                If gRideCode(Rdr) > 1 Or gRideSub(Rdr) = 0 Then
                    gRideNum(Rdr) = gRideNum(Rdr) + 1
                    If gMaxRides < gRideNum(Rdr) Then
                        gMaxRides = gRideNum(Rdr)
                        ReDim Preserve gRaceRes(40, gMaxRides)
                    End If
                    gRaceRes(Rdr, gRideNum(Rdr)) = gHeatCode(gRideCode(Rdr))
                    gRacePts(Rdr) = gRacePts(Rdr) + Val(gRaceRes(Rdr, gRideNum(Rdr)))
                    If gRacePts(Rdr) > gHighRdrScore Then gHighRdrScore = gRacePts(Rdr)
                End If
                
                ' Increments actual rides
                If gRideSub(Rdr) = 0 And gRideCode(Rdr) <> 2 Then
                    gActualRides(Rdr) = gActualRides(Rdr) + 1
                End If
                
                ' Updates tiebreak variables
                Select Case gRideCode(Rdr)
                    Case Is = 16
                        gTbrk(Rdr, 1) = gTbrk(Rdr, 1) + 1
                        gTmTbrk(gLineupNo(Rdr), 1) = gTmTbrk(gLineupNo(Rdr), 1) + 1
                    Case Is = 15
                        gTbrk(Rdr, 2) = gTbrk(Rdr, 2) + 1
                        gTmTbrk(gLineupNo(Rdr), 2) = gTmTbrk(gLineupNo(Rdr), 2) + 1
                    Case Is = 14
                        gTbrk(Rdr, 3) = gTbrk(Rdr, 3) + 1
                        gTmTbrk(gLineupNo(Rdr), 3) = gTmTbrk(gLineupNo(Rdr), 3) + 1
                    Case Is = 13
                        gTbrk(Rdr, 4) = gTbrk(Rdr, 4) + 1
                        gTmTbrk(gLineupNo(Rdr), 4) = gTmTbrk(gLineupNo(Rdr), 4) + 1
                    Case Is = 12
                        gTbrk(Rdr, 5) = gTbrk(Rdr, 5) + 1
                        gTmTbrk(gLineupNo(Rdr), 5) = gTmTbrk(gLineupNo(Rdr), 5) + 1
                    Case Is = 11
                        gTbrk(Rdr, 6) = gTbrk(Rdr, 6) + 1
                        gTmTbrk(gLineupNo(Rdr), 6) = gTmTbrk(gLineupNo(Rdr), 6) + 1
                    Case Is = 9
                        gTbrk(Rdr, 7) = gTbrk(Rdr, 7) + 1
                        gTmTbrk(gLineupNo(Rdr), 7) = gTmTbrk(gLineupNo(Rdr), 7) + 1
                    Case 2, 5, 6
                        gTbrk(Rdr, 8) = gTbrk(Rdr, 8) + 1
                        gTmTbrk(gLineupNo(Rdr), 8) = gTmTbrk(gLineupNo(Rdr), 8) + 1
                End Select
                
            End If
        Next Rdr
        
        ' Calls procedure to calculate bonus points if necessary
        ' OR marks race winner if Team Scoring is being used
        If gAddBonus > 0 Then
            BonusPtsCalc
        ElseIf gScoringType = 1 Then
            Select Case gHtDetail(gHeat, 1, 2)
                Case 10 To gNumStarters + 7
                    gRaceRes(gHtDetail(gHeat, 1, 1), gRideNum(gHtDetail(gHeat, 1, 1))) = gRaceRes(gHtDetail(gHeat, 1, 1), gRideNum(gHtDetail(gHeat, 1, 1))) + "'"
            End Select
        End If
        
        ' Calls procedure to calculate team scores if necessary
        If gNumTeams > 1 Then TeamScoresCalc
    
    Else
        gHtScore(gHeat, 0) = 1
    End If
    
    ' Updates longest line details
    If gHtDetail(gHeat, 0, 1) > gMaxHtLen Then
        gMaxHtLen = gHtDetail(gHeat, 0, 1)
    End If
    
    ' Displays race result in status bar
    Temp = "Heat " + Format(gHeat) + ":  "
    If gHtDetail(gHeat, 0, 1) = 0 Then
        Temp = Temp + "Race not held"
    Else
        For a = 1 To 8
            If gRdrName(gHtDetail(gHeat, a, 1)) <> "" Then
                If a > 1 Then Temp = Temp + ", "
                Temp = Temp + gRdrName(gHtDetail(gHeat, a, 1))
                If gHtDetail(gHeat, a, 2) < 9 And gHtDetail(gHeat, a, 3) > 0 Then
                    Temp = Temp + Space(1) + "(" + Format(gHtDetail(gHeat, a, 3), "0") + "/" + gHeatCode(gHtDetail(gHeat, a, 2)) + ")"
                ElseIf gHtDetail(gHeat, a, 2) < 9 Then
                    Temp = Temp + Space(1) + "(" + gHeatCode(gHtDetail(gHeat, a, 2)) + ")"
                ElseIf gHtDetail(gHeat, a, 3) > 0 Then
                    Temp = Temp + Space(1) + "(" + Format(gHtDetail(gHeat, a, 3), "0") + ")"
                End If
            End If
        Next a
    End If
    frmMainWin.sbrResults.SimpleText = Temp
    
End Sub

Public Sub Injuries(Score() As Single, Rdr As Integer, Lap As Integer)

    Dim Injury As Integer               ' Temporary variable
    Dim a As Integer                    ' Counter variable
    
    Injury = Int(Rnd * 6 + 1)
    
    If Injury = 1 Then
        gRdrAvge(gLineup(Rdr, 1)) = 0
        gRiding(gLineup(Rdr, 1)) = 2
    End If

    If gRideCode(gLineup(Rdr, 1)) <> 6 Then
        For a = 1 To gNumStarters
            If gRideCode(gLineup(a, 1)) = 9 And Score(a) <= Score(Rdr) Then
                Injury = Int(Rnd * 25 + 1)
                If Injury = 1 Then
                    gRdrAvge(gLineup(a, 1)) = 0
                    gRiding(gLineup(a, 1)) = 2
                    If Lap < 4 Then
                        gRideCode(gLineup(a, 1)) = 2
                    End If
                End If
            End If
        Next a
    End If

End Sub

Public Sub TeamScoresCalc()
    
    Dim Temp As Single                  ' Temporary variable
    Dim a As Integer                    ' Counter variable
    
    ' Calculates team scores from heat result
    For a = 1 To gNumStarters
        If gHtDetail(gHeat, a, 2) >= 9 Then
            If gAddBonus = 2 Then
                Temp = gLastRide(gHtDetail(gHeat, a, 1))
            Else
                Temp = gHtDetail(gHeat, a, 2)
            End If
            If gNumTeams = 2 Then
                gHtScore(gHeat, gLineupNo(gHtDetail(gHeat, a, 1)) + 2) = gHtScore(gHeat, gLineupNo(gHtDetail(gHeat, a, 1)) + 2) + Val(gHeatCode(Temp))
                If gHtScore(gHeat, gLineupNo(gHtDetail(gHeat, a, 1)) + 2) > gHighHtScore Then
                    gHighHtScore = gHtScore(gHeat, gLineupNo(gHtDetail(gHeat, a, 1)) + 2)
                End If
            End If
            gTmScore(gLineupNo(gHtDetail(gHeat, a, 1))) = gTmScore(gLineupNo(gHtDetail(gHeat, a, 1))) + Val(gHeatCode(Temp))
        End If
    Next a
    
    ' Updates heat details with progressive team scores
    For a = 1 To gNumTeams
        If gNumTeams <= 4 Then
            gHtScore(gHeat, a) = gTmScore(a)
        End If
        If gTmScore(a) > gHighTmScore Then
            gHighTmScore = gTmScore(a)
        End If
    Next a

End Sub

Public Sub BonusPtsCalc()

    Dim Front As Integer                ' Counter variable
    Dim Behind As Integer               ' Counter variable
    Dim Rdr As Integer                  ' Temporary variable
    Dim ok As Integer                   ' Check variable
    
    ' Calculates rider bonus points
    Front = 1
    Do
        Behind = Front + 1
        Do
            Rdr = gHtDetail(gHeat, Behind, 1)
            ok = 0
            If gLineupNo(gHtDetail(gHeat, Front, 1)) = gLineupNo(Rdr) And gHtDetail(gHeat, Behind, 2) > 9 And gHtDetail(gHeat, Behind, 1) <= gNumTeams * gNumRiders Then
                gRaceRes(Rdr, gRideNum(Rdr)) = gRaceRes(Rdr, gRideNum(Rdr)) + gHeatCode(17)
                gLastRide(Rdr) = gHtDetail(gHeat, Front, 2)
                gBonusPts(Rdr) = gBonusPts(Rdr) + Val(gHeatCode(gHtDetail(gHeat, Front, 2))) - Val(gHeatCode(gHtDetail(gHeat, Behind, 2)))
                If gBonusPts(Rdr) > gHighBnScore Then gHighBnScore = gBonusPts(Rdr)
                Behind = Behind + 1
                ok = 1
            Else
                Front = Behind
            End If
        Loop While ok = 1 And Behind <= gNumStarters
    Loop While Front <= gNumStarters - 1

End Sub

Public Sub RankAverages()

    Dim Reserves As Integer             ' Temporary variable
    Dim NotSort As Integer              ' Check variable
    Dim Temp As Integer                 ' Temporary variable
    Dim a As Integer                    ' Counter variable
    Dim b As Integer                    ' Counter variable
    
    If gNumGroups = 1 And gResType = 2 Then
        Reserves = gNumRes
    ElseIf gResType = 0 Then
        Reserves = gNumRes
    End If

    For a = 1 To gNumGroups

        ' Create status list
        For b = 1 To gNumRiders
            gRdrStatus(RiderID(a, b)) = RiderID(a, b)
        Next b

        ' Ranks riders
        Do
            NotSort = 0
            For b = RiderID(a, 1) To RiderID(a, gNumRiders - Reserves - gTeamRes - 1)
                If gRdrAvge(gRdrStatus(b)) < gRdrAvge(gRdrStatus(b + 1)) Then
                    Temp = gRdrStatus(b)
                    gRdrStatus(b) = gRdrStatus(b + 1)
                    gRdrStatus(b + 1) = Temp
                    NotSort = 1
                End If
            Next b
        Loop Until NotSort = 0

        ' Ranks reserves
        If gNumTeams > 1 And Reserves > 0 Then
            Do
                NotSort = 0
                For b = a * gNumRiders - Reserves - gTeamRes + 1 To a * gNumRiders - gTeamRes - 1
                    If gRdrAvge(gRdrStatus(b)) < gRdrAvge(gRdrStatus(b + 1)) Then
                        Temp = gRdrStatus(b)
                        gRdrStatus(b) = gRdrStatus(b + 1)
                        gRdrStatus(b + 1) = Temp
                        NotSort = 1
                    End If
                Next b
            Loop Until NotSort = 0
        End If
        
        ' Configures R/R facility if required
        For b = 1 To gNumRiders
            If gRdrRepFac(a, 1) = gRdrStatus(RiderID(a, b)) Then
                gRdrAvge(gRdrStatus(RiderID(a, b))) = 0
                gRdrRepFac(a, 2) = b
            End If
        Next b
        
    Next a

End Sub

Public Sub RankRiderScores()
    
    Dim Reserves As Integer             ' Temporary variable
    Dim NotSort As Integer              ' Check variable
    Dim Temp As Integer                 ' Temporary variable
    Dim Comp1 As Single                 ' Comparison variable
    Dim Comp2 As Single                 ' Comparison variable
    Dim a As Integer                    ' Counter variable
    Dim b As Integer                    ' Counter variable
    Dim c As Integer                    ' Counter variable
    
    If gNumGroups = 1 And gResType = 2 Then
        Reserves = gNumRes
    ElseIf gResType = 0 Then
        Reserves = gNumRes
    End If

    For a = 1 To gNumGroups
        Do
            NotSort = 0
            For b = 1 To gNumRiders - Reserves - gTeamRes - 1
                Comp1 = gRacePts(gRdrRnk(RiderID(a, b))) + gBonusPts(gRdrRnk(RiderID(a, b)))
                Comp2 = gRacePts(gRdrRnk(RiderID(a, b + 1))) + gBonusPts(gRdrRnk(RiderID(a, b + 1)))
                If Comp1 < Comp2 Then
                    Temp = gRdrRnk(RiderID(a, b))
                    gRdrRnk(RiderID(a, b)) = gRdrRnk(RiderID(a, b + 1))
                    gRdrRnk(RiderID(a, b + 1)) = Temp
                    NotSort = 1
                ElseIf Comp1 = Comp2 And gNumTeams > 1 Then
                    Comp1 = gRdrAvge(gRdrRnk(RiderID(a, b)))
                    Comp2 = gRdrAvge(gRdrRnk(RiderID(a, b + 1)))
                    If Comp1 < Comp2 Then
                        Temp = gRdrRnk(RiderID(a, b))
                        gRdrRnk(RiderID(a, b)) = gRdrRnk(RiderID(a, b + 1))
                        gRdrRnk(RiderID(a, b + 1)) = Temp
                        NotSort = 1
                    End If
                ElseIf Comp1 = Comp2 Then
                    For c = 0 To 8
                        Comp1 = gTbrk(gRdrRnk(RiderID(a, b)), c)
                        Comp2 = gTbrk(gRdrRnk(RiderID(a, b + 1)), c)
                        If Comp1 < Comp2 Then
                            Temp = gRdrRnk(RiderID(a, b))
                            gRdrRnk(RiderID(a, b)) = gRdrRnk(RiderID(a, b + 1))
                            gRdrRnk(RiderID(a, b + 1)) = Temp
                            NotSort = 1
                            Exit For
                        ElseIf Comp1 > Comp2 Then
                            Exit For
                        End If
                    Next c
                End If
            Next b
        Loop Until NotSort = 0
    Next a
    
End Sub

Public Sub RankTeamScores()
    
    Dim NotSort As Integer              ' Check variable
    Dim Temp As Integer                 ' Temporary variable
    Dim a As Integer                    ' Counter variable
    Dim b As Integer                    ' Counter variable

    Do
        NotSort = 0
        For a = 1 To gNumTeams - 1
            If gTmScore(gTmRnk(a)) < gTmScore(gTmRnk(a + 1)) Then
                Temp = gTmRnk(a)
                gTmRnk(a) = gTmRnk(a + 1)
                gTmRnk(a + 1) = Temp
                NotSort = 1
            ElseIf gTmScore(gTmRnk(a)) = gTmScore(gTmRnk(a + 1)) Then
                For b = 0 To 8
                    If gTmTbrk(gTmRnk(a), b) < gTmTbrk(gTmRnk(a + 1), b) Then
                        Temp = gTmRnk(a)
                        gTmRnk(a) = gTmRnk(a + 1)
                        gTmRnk(a + 1) = Temp
                        NotSort = 1
                        Exit For
                    ElseIf gTmTbrk(gTmRnk(a), b) > gTmTbrk(gTmRnk(a + 1), b) Then
                        Exit For
                    End If
                Next b
            End If
        Next a
    Loop Until NotSort = 0

End Sub

Public Sub Replacements()

    Dim Chk As Integer                  ' Check variable
    Dim Rdr As Integer                  ' Temporary variable
    Dim a As Integer                    ' Counter variable
    Dim ok As Integer                   ' Check variable

    ' Selects substitute riders when a replacement facility is operational
    If gLineup(gGate, 1) = gRdrRepFac(gLineupNo(gLineup(gGate, 1)), 1) And gLineup(gGate, 1) <> 0 Then
        If gRdrRepFac(gLineupNo(gLineup(gGate, 1)), 2) > gRdrRep Then
            Chk = gRdrRepFac(gLineupNo(gLineup(gGate, 1)), 2) - gRdrRep
        Else
            Chk = 1
        End If
        If Chk <= gNumRiders - gNumRes - gTeamRes Then
            Do
                Rdr = gRdrStatus(RiderID(gLineupNo(gLineup(gGate, 1)), Chk))
                If gRdrRepRides(Rdr) = 0 And gRdrAvge(Rdr) <> 0 Then
                    a = 1: ok = 1
                    Do
                        If Rdr = gLineup(a, 1) Then ok = 0
                        a = a + 1
                    Loop Until ok = 0 Or a > gNumStarters
                    If ok = 1 Then
                        gLineup(gGate, 1) = Rdr
                        gLineup(gGate, 5) = Handicap(Rdr)
                        gRdrRepRides(Rdr) = 1
                    End If
                End If
                Chk = Chk + 1
            Loop Until ok = 1 Or Chk > gNumRiders - gNumRes - gTeamRes
        End If
    End If

End Sub

Public Sub TacticalSubs()

    Dim Team As Integer                 ' Counter variable
    Dim a As Integer                    ' Counter variable
    Dim Reserves As Integer             ' Number of reserves
    Dim TeamRes As Integer              ' Determines use of Team Reserves
    Dim ChoiceNum As Integer            ' Check variable
    Dim NotSort As Integer              ' Check variable
    Dim Chk1 As Integer                 ' Check variable
    Dim Chk2 As Integer                 ' Check variable
    Dim Chk3 As Integer                 ' Check variable
    Dim ok As Integer                   ' Check variable
    Dim Temp As Integer                 ' Temporary variable
    Dim Rdr As Integer                  ' Temporary variable
    Dim Choice(1 To 4) As Integer       ' Tactical sub preferences
    
    For Team = 1 To gNumTeams

        ok = 0
        If gControl(Team) = 0 Then
        
            ' Checks whether T/S is valid and determines riders to substitute
            a = 1: ChoiceNum = 0
            Do
                If gLineupNo(gLineup(a, 1)) = Team Then
                    ChoiceNum = ChoiceNum + 1
                    Choice(ChoiceNum) = a
                ElseIf gTmScore(gLineupNo(gLineup(a, 1))) - gTmScore(Team) >= gTacEnable Then
                    ok = 1
                End If
                a = a + 1
            Loop Until a > gNumStarters Or ChoiceNum = 4
            
        End If
            
        If ok = 1 Then
  
            ' Sorts rider choices
            If ChoiceNum > 1 Then
                Do
                    NotSort = 0
                    For a = 1 To ChoiceNum - 1
                        If gRdrAvge(gLineup(Choice(a), 1)) > gRdrAvge(gLineup(Choice(a + 1), 1)) Then
                            Temp = Choice(a)
                            Choice(a) = Choice(a + 1)
                            Choice(a + 1) = Temp
                            NotSort = 1
                        End If
                    Next a
                Loop Until NotSort = 0
            End If
            
            If gRdrRepFac(Team, 2) > gNumRiders - gNumRes - gTeamRes Then
                Reserves = gNumRes + 1
                TeamRes = 0
            Else
                Reserves = gNumRes
                TeamRes = gTeamRes
            End If
            
            ' Determines substitute rider
            For Chk1 = 1 To ChoiceNum
                If RideCalc(gLineup(Choice(Chk1), 1)) = 0 Then
                    Chk2 = 1: ok = 0
                    Do
                        If Chk2 <= gNumRiders - Reserves - TeamRes Or Chk2 > gNumRiders - TeamRes Then
                            Rdr = gRdrStatus(RiderID(Team, Chk2))
                            If gTacSubRides(Rdr) = 0 And gRdrAvge(Rdr) > gRdrAvge(gLineup(Choice(Chk1), 1)) Then
                                a = 1: ok = 1
                                Do
                                    If gLineup(Choice(a), 1) = Rdr Then ok = 0
                                    a = a + 1
                                Loop Until ok = 0 Or a > 4
                                If ok = 1 And gTacMode = 1 Then
                                    Chk3 = 1
                                    Do
                                        If gLineup(Choice(Chk1), 1) = gRdrStatus(RiderID(Team, Chk3)) And gRdrAvge(gLineup(Choice(Chk1), 1)) <> 0 Then
                                            ok = 0
                                        End If
                                        Chk3 = Chk3 + 1
                                    Loop Until ok = 0 Or Chk3 > gNumRiders - Int(gNumRiders / 2)
                                End If
                                If ok = 1 Then
                                    gLineup(Choice(Chk1), 1) = Rdr
                                    gTacSubRides(Rdr) = 1
                                End If
                            End If
                        End If
                        Chk2 = Chk2 + 1
                    Loop Until ok = 1 Or Chk2 > gNumRiders
                End If
            Next Chk1

        End If

    Next Team

End Sub

Public Function RideCalc(Rider As Integer) As Integer

    ' Calculates if competitor fulfills minimum ride criteria
    If Rider <> gRdrRepFac(gLineupNo(Rider), 1) Then
        If gAvlRides(Rider) + gActualRides(Rider) < gMinRides Then
            If gRdrAvge(Rider) <> 0 Or gRiding(Rider) < 2 Then RideCalc = 1
        End If
    End If

End Function

Public Sub DetermineRunoffs()

    Dim a As Integer                    ' Counter variable
    Dim Complete As Integer             ' Check variable
    Dim Runoff As Integer               ' Current runoff
    Dim Ptr As Integer                  ' Check variable
    Dim ok As Integer                   ' Check variable
    Dim Comp1 As Integer                ' Check variable
    Dim Comp2 As Integer                ' Check variable
    Dim Starters As Integer             ' Temporary variable
    Dim Max As Integer                  ' Temporary variable
        
    ' Sort scores
    RankTeamScores
    RankRiderScores

    ' Select first check position
    Select Case gRunoffUse
        Case 3
            gCheckPos = 3
        Case Else
            gCheckPos = gCheckPos + 1
    End Select
    
    ' Reinitialises runoff details
    ReDim gRunoffInfo(3, 2)
    Runoff = 1
    
    Do
        ReDim NumTies(1 To 2) As Integer

        ' Checks for tied scores
        For a = 1 To 2
            If a = 1 Then Ptr = 1 Else Ptr = -1
            Do
                ok = 1
                If gNumTeams > 1 And gCheckPos + Ptr > 0 And gCheckPos + Ptr <= gNumTeams Then
                    Comp1 = gTmScore(gTmRnk(gCheckPos + Ptr)) + gAddPts(gTmRnk(gCheckPos + Ptr))
                    Comp2 = gTmScore(gTmRnk(gCheckPos)) + gAddPts(gTmRnk(gCheckPos))
                    If Comp1 = Comp2 Then
                        NumTies(a) = NumTies(a) + 1
                        If a = 1 Then
                            Ptr = Ptr + 1
                        Else
                            Ptr = Ptr - 1
                        End If
                        ok = 0
                    End If
                ElseIf gNumTeams = 1 And gCheckPos + Ptr > 0 And gCheckPos + Ptr <= gNumRiders Then
                    If gRacePts(gRdrRnk(gCheckPos + Ptr)) = gRacePts(gRdrRnk(gCheckPos)) Then
                        NumTies(a) = NumTies(a) + 1
                        If a = 1 Then
                            Ptr = Ptr + 1
                        Else
                            Ptr = Ptr - 1
                        End If
                        ok = 0
                    End If
                End If
            Loop Until ok = 1
        Next a
        
        ' Determines maximum number of starters
        If gNumStarters = 2 Then
            Max = 2
        Else
            Max = gNumStarters * 2
        End If
        
        ' Records runoff information
        Starters = NumTies(1) + NumTies(2) + 1
        If Starters >= 2 And Starters <= Max Then
            If gNumTeams = 1 Or gCheckPos <= 3 Or NumTies(2) <> 0 Then
                gRunoffInfo(0, 0) = gRunoffInfo(0, 0) + 1
                gRunoffInfo(Runoff, 1) = gCheckPos - NumTies(2)
                gRunoffInfo(Runoff, 2) = Starters
                Runoff = Runoff + 1
            End If
        End If
        
        ' Selects next check position if required
        If gRunoffUse = 4 And gCheckPos - NumTies(2) > 3 Then
            gCheckPos = 3
        ElseIf gRunoffUse > 2 And gCheckPos - NumTies(2) > 2 Then
            gCheckPos = 2
        Else
            Complete = 1
        End If

    Loop Until Complete = 1
    
    ' Stages runoffs if necessary
    If gRunoffInfo(0, 0) > 0 Then
        gRunoff = 1
        gSubRunoff = 1
        If gInteractive = 0 Then
            Runoffs
        Else
            gFinished = 1
        End If
    End If
      
End Sub

Public Sub ReserveSubs()

    Dim TotalRes As Integer                 ' Number of substitutes to define
    Dim TeamRes As Integer                  ' Determines use of Team Reserve
    Dim a As Integer                        ' Counter variable
    Dim NotSort As Integer                  ' Check variable
    Dim ok As Integer                       ' Check variable
    Dim Override As Integer                 ' Check variable
    Dim Chk As Integer                      ' Check variable
    Dim Temp As Integer                     ' Temporary variable
    
    If RideCalc(gLineup(gGate, 1)) = 0 Then
  
        ' Creates a list of substitutes
        If gLineup(gGate, 2) > 0 And gLineup(gGate, 3) > 0 Then
            TotalRes = 8 - gLineup(gGate, 2) + 1
            ReDim Reserves(TotalRes) As Integer
            For a = 1 To TotalRes
                Reserves(a) = gHtDetail(gLineup(gGate, 3), gLineup(gGate, 2) + a - 1, 1)
            Next a
            Override = 1
        ElseIf gLineup(gGate, 2) > 0 Then
            TotalRes = gLineupNo(gLineup(gGate, 2)) * gNumRiders - gLineup(gGate, 2) + 1
            ReDim Reserves(TotalRes) As Integer
            For a = 1 To TotalRes
                Reserves(a) = gRdrRnk(gLineup(gGate, 2) + a - 1)
            Next a
            Override = 1
        ElseIf gNumRes > 0 And gLineup(gGate, 1) <> 0 And gSupportComp = False Then
            If gRdrRepFac(gLineupNo(gLineup(gGate, 1)), 2) > gNumRiders - gNumRes - gTeamRes Then
                TotalRes = gNumRes + 1
            Else
                TotalRes = gNumRes
                TeamRes = gTeamRes
            End If
            
            ReDim Reserves(TotalRes) As Integer
            For a = 1 To TotalRes
                If gNumGroups >= 2 And gResType = 2 Then
                    Reserves(a) = gNumGroups * gNumRiders + a
                Else
                    Reserves(a) = gRdrStatus(gLineupNo(gLineup(gGate, 1)) * gNumRiders - gNumRes - gTeamRes + a)
                End If
            Next a
            
            ' Sorts the substitute list
            Do
                NotSort = 0
                For a = 1 To TotalRes - 1
                    If gRideNum(Reserves(a)) > gRideNum(Reserves(a + 1)) Then
                        Temp = Reserves(a)
                        Reserves(a) = Reserves(a + 1)
                        Reserves(a + 1) = Temp
                        NotSort = 1
                    End If
                Next a
            Loop Until NotSort = 0
        End If
  
        ' Makes a substitution if possible
        If TotalRes > 0 Then
            Chk = 1
            Do
                If gRdrAvge(Reserves(Chk)) <> 0 Then
                    If Override = 1 Or gMaxResRides - gRideNum(Reserves(Chk)) > gAvlRides(Reserves(Chk)) Then
                        If gRideSub(Reserves(Chk)) = 0 Then
                            ok = 1
                            For a = 1 To gNumStarters
                                If gLineup(a, 1) = Reserves(Chk) Then ok = 0
                            Next a
                            If ok = 1 Then
                                gRideSub(gLineup(gGate, 1)) = 1
                                gLineup(gGate, 1) = Reserves(Chk)
                                gLineup(gGate, 5) = Handicap(Reserves(Chk))
                                gGate = gGate - 1
                            End If
                        End If
                    End If
                End If
                Chk = Chk + 1
            Loop Until ok = 1 Or Chk > TotalRes
        End If
        
        ' Tries Team Reserve if R/R is being used
        If ok = 0 And TeamRes = 1 Then
            If gRdrRepFac(gLineupNo(gLineup(gGate, 1)), 1) = gLineup(gGate, 1) Then
                If gRdrAvge(RiderID(gLineupNo(gLineup(gGate, 1)), gNumRiders)) <> 0 Then
                    ok = 1
                    For a = 1 To gNumStarters
                        If gLineup(a, 1) = RiderID(gLineupNo(gLineup(gGate, 1)), gNumRiders) Then ok = 0
                    Next a
                    If ok = 1 Then
                        gRideSub(gLineup(gGate, 1)) = 1
                        gLineup(gGate, 1) = RiderID(gLineupNo(gLineup(gGate, 1)), gNumRiders)
                        gLineup(gGate, 5) = Handicap(gLineup(gGate, 1))
                        gGate = gGate - 1
                    End If
                End If
            End If
        End If

    End If

End Sub

Public Sub ScratchRacing()

    Dim Players As Integer                          ' Temporarily saves mode info
    
    ' Saves existing mode info and sets new mode
    Players = gInteractive: gInteractive = 2
    If gProgHeats > 0 Then gScoring = 0
    gTacMode = 0
    gRdrRepMode = 0
    
    ' Reinitialises heat configuration
    ReDim gLineup(8, 5), gRideCode(40), gRideSub(40)
    gHeatTitle = ""
  
    RaceCalculation
    
    If gFinished = 1 Then
        If gProgHeats > 0 Then gFinished = 3
        DisplayResults
    End If
  
    ' Restores mode info
    gInteractive = Players

End Sub

Public Sub Runoffs()

    Dim Gate As Integer                 ' Counter variable
    Dim a As Integer                    ' Counter variable
    Dim b As Integer                    ' Counter variable
    Dim ok As Integer                   ' Check variable
    Dim Start As Integer                ' Temporary variable
    Dim Finish As Integer               ' Temporary variable
    Dim Temp As Integer                 ' Temporary variable
    Dim Scoring As Integer              ' Temporarily saves mode info
    Dim ResUse As Integer               ' Temporarily saves mode info
    Dim TacMode As Integer              ' Temporarily saves mode info
    Dim RdrRepMode As Integer           ' Temporarily saves mode info
        
    ' Saves existing mode info and sets new modes
    Scoring = gScoring: gScoring = 0
    TacMode = gTacMode: gTacMode = 0
    RdrRepMode = gRdrRepMode: gRdrRepMode = 0
    If gNumTeams = 1 Then
        ResUse = gResUse: gResUse = 7
    End If
    
    Do
    
        ' Creates Heat Title
        If gNumTeams = 2 Then
            gHeatTitle = "Runoff"
        Else
            gHeatTitle = "Runoff for "
            For a = 1 To 2
                If a = 1 Then
                    Temp = gRunoffInfo(gRunoff, 1)
                Else
                    Temp = gRunoffInfo(gRunoff, 1) + gRunoffInfo(gRunoff, 2) - 1
                    gHeatTitle = gHeatTitle + "-"
                End If
                If Right(Format(Temp), 1) = 1 And Temp <> 11 Then
                    gHeatTitle = gHeatTitle + Format(Temp) + "st"
                ElseIf Right(Format(Temp), 1) = 2 And Temp <> 12 Then
                    gHeatTitle = gHeatTitle + Format(Temp) + "nd"
                ElseIf Right(Format(Temp), 1) = 3 And Temp <> 13 Then
                    gHeatTitle = gHeatTitle + Format(Temp) + "rd"
                Else
                    gHeatTitle = gHeatTitle + Format(Temp) + "th"
                End If
             Next a
        End If
        
        If gFinished <> 2 Then
        
            ' Ballot for gate positions
            ReDim GatePos(gNumStarters)
            For a = 1 To gNumStarters
                Do
                    Temp = Int(Rnd * gNumStarters + 1)
                    ok = 1
                    For b = 1 To a
                        If Temp = GatePos(b) Then ok = 0
                    Next b
                    If ok = 1 Then GatePos(a) = Temp
                Loop Until ok = 1
            Next a
        
            'Creates runoff line-up
            ReDim gLineup(8, 5), gRideCode(40), gRideSub(40)
            Select Case gSubRunoff
                Case 1
                    If gRunoffInfo(gRunoff, 2) > gNumStarters Then
                        Finish = gRunoffInfo(gRunoff, 2) - Int(gRunoffInfo(gRunoff, 2) / 2)
                    Else
                        Finish = gRunoffInfo(gRunoff, 2)
                    End If
                    Gate = 0
                    For a = 1 To Finish
                        Gate = Gate + 1
                        If gNumTeams > 1 Then
                            gLineup(GatePos(Gate), 1) = gRdrRnk(RiderID(gTmRnk(gRunoffInfo(gRunoff, 1) + a - 1), 1))
                            gLineup(GatePos(Gate), 2) = 1
                        Else
                            gLineup(GatePos(Gate), 1) = gRdrRnk(gRunoffInfo(gRunoff, 1) + a - 1)
                        End If
                    Next a
                Case 2
                    Gate = 0
                    For a = gRunoffInfo(gRunoff, 2) - Int(gRunoffInfo(gRunoff, 2) / 2) + 1 To gRunoffInfo(gRunoff, 2)
                        Gate = Gate + 1
                        If gNumTeams > 1 Then
                            gLineup(GatePos(Gate), 1) = gRdrRnk(RiderID(gTmRnk(gRunoffInfo(gRunoff, 1) + a - 1), 1))
                            gLineup(GatePos(Gate), 2) = 1
                        Else
                            gLineup(GatePos(Gate), 1) = gRdrRnk(gRunoffInfo(gRunoff, 1) + a - 1)
                        End If
                    Next a
                Case 3
                    Gate = 0
                    For a = 1 To 2
                        If a = 1 And gNumStarters / 2 - Int(gNumStarters / 2) <> 0 Then
                            Start = Int(gHtDetail(gHeat - 2 + a, 0, 2) / 2) + 2
                        Else
                            Start = Int(gHtDetail(gHeat - 2 + a, 0, 2) / 2) + 1
                        End If
                        For b = Start To gHtDetail(gHeat - 2 + a, 0, 2)
                            Gate = Gate + 1
                            gLineup(GatePos(Gate), 1) = gHtDetail(gHeat - 2 + a, b, 1)
                            If gNumTeams > 1 Then
                                gLineup(GatePos(Gate), 2) = 1
                            End If
                        Next b
                    Next a
                Case 4
                    Gate = 0
                    For a = 1 To 2
                        If a = 1 And gNumStarters / 2 - Int(gNumStarters / 2) <> 0 Then
                            Finish = Int(gHtDetail(gHeat - 3 + a, 0, 2) / 2) + 1
                        Else
                            Finish = Int(gHtDetail(gHeat - 3 + a, 0, 2) / 2)
                        End If
                        For b = 1 To Finish
                            Gate = Gate + 1
                            gLineup(GatePos(Gate), 1) = gHtDetail(gHeat - 3 + a, b, 1)
                            If gNumTeams > 1 Then
                                gLineup(GatePos(Gate), 2) = 1
                            End If
                        Next b
                    Next a
                    If Gate < gNumStarters Then
                        For a = 1 To gNumStarters - Gate
                            Gate = Gate + 1
                            gLineup(GatePos(Gate), 1) = gHtDetail(gHeat, a, 1)
                            If gNumTeams > 1 Then
                                gLineup(GatePos(Gate), 2) = 1
                            End If
                        Next a
                    End If
            End Select
        
        End If
    
        If gHeat < 40 Then RaceCalculation
    
        ' Update tiebreak variables
        If gFinished <> 2 Then
            If gRunoffInfo(gRunoff, 2) <= gNumStarters Then
                For a = 1 To gHtDetail(gHeat, 0, 2)
                    gTbrk(gHtDetail(gHeat, a, 1), 0) = gNumStarters - a
                    gTmTbrk(gLineupNo(gHtDetail(gHeat, a, 1)), 0) = gNumStarters - a
                Next a
                If gRunoff < gRunoffInfo(0, 0) Then
                    gRunoff = gRunoff + 1
                    gSubRunoff = 1
                Else
                    gRunoff = 0
                End If
            ElseIf gSubRunoff = 4 Then
                For a = 1 To gHtDetail(gHeat - 1, 0, 2)
                    gTbrk(gHtDetail(gHeat - 1, a, 1), 0) = gNumStarters - a
                    gTmTbrk(gLineupNo(gHtDetail(gHeat - 1, a, 1)), 0) = gNumStarters - a
                Next a
                For a = 1 To gHtDetail(gHeat, 0, 2)
                    gTbrk(gHtDetail(gHeat, a, 1), 0) = gNumStarters * 2 - a
                    gTmTbrk(gLineupNo(gHtDetail(gHeat, a, 1)), 0) = gNumStarters * 2 - a
                Next a
                If gRunoff < gRunoffInfo(0, 0) Then
                    gRunoff = gRunoff + 1
                    gSubRunoff = 1
                Else
                    gRunoff = 0
                End If
            Else
                gSubRunoff = gSubRunoff + 1
            End If
            If gProgHeats > 0 Then
                gProgHeats = gProgHeats + 1
            End If
        End If
    
    Loop Until gRunoff = 0 Or gInteractive = 1
    
    ' Restores mode info
    gScoring = Scoring
    gTacMode = TacMode
    gRdrRepMode = RdrRepMode
    If gNumTeams = 1 Then
        gResUse = ResUse
    End If
    
End Sub

Public Sub SupportRacing()
    
    ' Calls Programme Editor if necessary
    If gAddRdrs > 0 Then frmProgEditor.Show vbModal
    
    ' Runs support competition
    If gAddRdrs = 0 Or gFinished = True Then
        gScoring = 0
        gTacMode = 0
        gRdrRepMode = 0
        UpdateMenus
        RunMeeting
    End If
    
End Sub

Public Function RiderID(Team As Integer, Rider As Integer) As Integer
  
    ' Calculates rider ID
    If Team = 0 Then
        RiderID = 0
    Else
        RiderID = Team * gNumRiders - gNumRiders + Rider
    End If
    
End Function

Public Sub UpdateMenus()
    
    If gInteractive > 0 And gFinished < 3 Then
        frmMainWin.mnuMSep.Visible = True
        frmMainWin.mnuMScratch.Visible = False
        frmMainWin.mnuMContinue.Visible = True
    ElseIf gFinished = 3 Then
        frmMainWin.mnuMSep.Visible = True
        frmMainWin.mnuMScratch.Visible = True
        frmMainWin.mnuMContinue.Visible = False
    Else
        frmMainWin.mnuMSep.Visible = False
        frmMainWin.mnuMScratch.Visible = False
        frmMainWin.mnuMContinue.Visible = False
    End If
         
    If gSupportComp = True And gFinished = 3 And gRunoff = 0 Then
        frmMainWin.mnuMSupport.Visible = True
    Else
        frmMainWin.mnuMSupport.Visible = False
    End If
    
    If gHeat < 40 Then
        frmMainWin.mnuMScratch.Enabled = True
        frmMainWin.mnuMSupport.Enabled = True
        frmMainWin.mnuMContinue.Enabled = True
    Else
        frmMainWin.mnuMScratch.Enabled = False
        frmMainWin.mnuMSupport.Enabled = False
        frmMainWin.mnuMContinue.Enabled = False
    End If
    
    If gFinished <> 0 And gHeat < 40 Then
        frmMainWin.mnuMSuspend.Enabled = True
    Else
        frmMainWin.mnuMSuspend.Enabled = False
    End If
    
End Sub

Public Sub TransferRider(CmdStr As String)
    
    Dim a As Integer                        ' Counter variable
    Dim Temp As String                      ' Temporary variable
    Dim Rider(2) As Integer                 ' Temporary variable
    ReDim Field(0) As String                ' Used to parse command string
    
    ' Parses command string
    Parse CmdStr, ">", Field(), 2
        
    For a = 1 To 2
        Select Case Asc(UCase(Left(Field(a), 1)))
            Case 65 To gNumGroups + 64
                Select Case UCase(Mid(Field(a), 2, 1))
                    Case "R"
                        If a = 1 Then
                            Select Case Val(Mid(Field(a), 3))
                                Case 1 To gNumRiders
                                    Rider(a) = gRdrStatus(RiderID(Asc(UCase(Left(Field(a), 1))) - 64, Val(Mid(Field(a), 3))))
                            End Select
                        End If
                    Case "S"
                        If a = 1 Then
                            Select Case Val(Mid(Field(a), 3))
                                Case 1 To gNumRiders
                                    Rider(a) = gRdrRnk(RiderID(Asc(UCase(Left(Field(a), 1))) - 64, Val(Mid(Field(a), 3))))
                            End Select
                        End If
                    Case Else
                        Select Case Val(Mid(Field(a), 2))
                            Case 1 To gNumRiders
                                Rider(a) = RiderID(Asc(UCase(Left(Field(a), 1))) - 64, Val(Mid(Field(a), 2)))
                        End Select
                End Select
            Case 83                             ' S prefix
                If a = 1 Then
                    Select Case Asc(UCase(Mid(Field(a), 2, 1)))
                        Case 65 To gNumGroups + 64
                            Select Case UCase(Mid(Field(a), 3, 1))
                                Case "R"
                                    Select Case Val(Mid(Field(a), 4))
                                        Case 1 To gNumRiders
                                            Rider(a) = gRdrStatus(RiderID(gTmRnk(Asc(UCase(Mid(Field(a), 2, 1))) - 64), Val(Mid(Field(a), 4))))
                                    End Select
                                Case "S"
                                    Select Case Val(Mid(Field(a), 4))
                                        Case 1 To gNumRiders
                                            Rider(a) = gRdrRnk(RiderID(gTmRnk(Asc(UCase(Mid(Field(a), 2, 1))) - 64), Val(Mid(Field(a), 4))))
                                    End Select
                                Case Else
                                    Select Case Val(Mid(Field(a), 3))
                                        Case 1 To gNumRiders
                                            Rider(a) = RiderID(gTmRnk(Asc(UCase(Mid(Field(a), 2, 1))) - 64), Val(Mid(Field(a), 3)))
                                    End Select
                            End Select
                    End Select
                End If
        End Select
    Next a
    
    ' Copies rider variables to different riding number
    If Rider(1) <> Rider(2) And Rider(2) <> 0 And gRdrName(Rider(2)) = "" Then
        gRdrName(Rider(2)) = gRdrName(Rider(1))
        gRdrAvge(Rider(2)) = gRdrAvge(Rider(1))
    End If
                        
End Sub

Public Sub TransferTeam(CmdStr As String)

    Dim a As Integer                        ' Counter variable
    Dim Temp As String                      ' Temporary variable
    Dim Team(2) As Integer                  ' Temporary variable
    ReDim Field(0) As String                ' Used to parse command string
    
    ' Parses command string
    Parse CmdStr, ">", Field(), 2
        
    For a = 1 To 2
        If a = 1 And UCase(Left(Field(a), 1)) = "S" Then
            Select Case Asc(UCase(Mid(Field(a), 2, 1)))
                Case 65 To gNumTeams + 64
                    Team(a) = gTmRnk(Asc(UCase(Mid(Field(a), 2, 1))) - 64)
            End Select
        Else
            Select Case Asc(UCase(Left(Field(a), 1)))
                Case 65 To gNumTeams + 64
                    Team(a) = Asc(UCase(Left(Field(a), 1))) - 64
            End Select
        End If
    Next a
    
    ' Copies team variables to different riding number
    If Team(1) <> Team(2) And Team(2) <> 0 And gTmName(Team(2)) = "" Then
        gTmName(Team(2)) = gTmName(Team(1))
        gAddPts(Team(2)) = gAddPts(Team(1))
        For a = 1 To gNumRiders
            gRdrName(RiderID(Team(2), a)) = gRdrName(RiderID(Team(1), a))
            gRdrAvge(RiderID(Team(2), a)) = gRdrAvge(RiderID(Team(1), a))
        Next a
    End If
    
End Sub

Public Sub GetSettings()
    
    Dim KeyIdx As Long                      ' Counter variable
    Dim a As Integer                        ' Counter variable
    Dim Result As String                    ' Result of Registry access
    Dim MainWinX As Integer                 ' X position of Main Window
    Dim MainWinY As Integer                 ' Y position of Main Window
    Dim MainWinHeight As Integer            ' Height of Main Window
    Dim MainWinWidth As Integer             ' Width of Main Window
    Dim MainWinState As Integer             ' Opening state of Main Window
    Dim Temp As String                      ' Temporary variable
    ReDim Field(0) As String                ' Used to parse registry settings
    
    ReDim gDefControl(9), gDefHeatCode(17)
    
    ' Creates registry keys if necessary
    If Val(GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting", "Version")) < Val(gVersion) Then
        RegDeleteKey HKEY_CURRENT_USER, "SOFTWARE\Speedway Meeting"
        Shell "Regedit.exe /s " & "Speedway.reg", vbNormalFocus
    End If
    
    If CheckRegKey(HKEY_CLASSES_ROOT, "SpwyMtg.SavedMtg", 0) = "" Then
        SaveRegString HKEY_CLASSES_ROOT, "SpwyMtg.SavedMtg", "", "Speedway Meeting Competition"
    End If
    
    If CheckRegKey(HKEY_CLASSES_ROOT, ".mtg", 0) = "" Then
        SaveRegString HKEY_CLASSES_ROOT, ".mtg", "", "SpwyMtg.SavedMtg"
    End If
    
    If CheckRegKey(HKEY_CLASSES_ROOT, "SpwyMtg.RiderDB", 0) = "" Then
        SaveRegString HKEY_CLASSES_ROOT, "SpwyMtg.RiderDB", "", "Speedway Meeting Rider Database"
    End If
    
    If CheckRegKey(HKEY_CLASSES_ROOT, ".rdb", 0) = "" Then
        SaveRegString HKEY_CLASSES_ROOT, ".rdb", "", "SpwyMtg.RiderDB"
    End If
    
    SaveRegString HKEY_CLASSES_ROOT, "SpwyMtg.SavedMtg\shell\open\command", "", App.Path + "\Speedway.exe" + " %1"
    SaveRegString HKEY_CLASSES_ROOT, "SpwyMtg.SavedMtg\DefaultIcon", "", App.Path + "\Speedway.exe" + ",0"
    SaveRegString HKEY_CLASSES_ROOT, "SpwyMtg.RiderDB\shell\open\command", "", App.Path + "\RdrEditor.exe" + " %1"
    SaveRegString HKEY_CLASSES_ROOT, "SpwyMtg.RiderDB\DefaultIcon", "", App.Path + "\RdrEditor.exe" + ",0"
    
    ' Reads Registry Keys
    Do
        Result = CheckRegKey(HKEY_CURRENT_USER, "Software\Speedway Meeting\Competitions", KeyIdx)
        If Result <> "" Then
            Temp = GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting\Competitions", Result)
            Parse Temp, ",", Field(), 2
            If Field(1) <> "" And Field(1) <> "-" Then
                gCompNum = gCompNum + 1
                Load frmMainWin.mnuFNComp(gCompNum)
                frmMainWin.mnuFNSep.Visible = True
                frmMainWin.mnuFNComp(gCompNum).Visible = True
                frmMainWin.mnuFNComp(gCompNum).Caption = Left(Field(1), 40)
                frmMainWin.mnuFNComp(gCompNum).Tag = Field(2)
            End If
        End If
        KeyIdx = KeyIdx + 1
    Loop While Result <> "" And gCompNum < 99
    
    SetMenuCols
    
    gDefMaxAvge = Val(GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting", "DefMaxAvge"))
    gDefHomeAdv = Val(GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting", "DefHomeAdv"))
    gDefStartPrefs = Val(GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting", "DefStartPrefs"))
    gRdrFile = GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting", "RiderFile")
    MainWinX = Val(GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting\MainWindow", "Left"))
    MainWinY = Val(GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting\MainWindow", "Top"))
    MainWinHeight = Val(GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting\MainWindow", "Height"))
    MainWinWidth = Val(GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting\MainWindow", "Width"))
    MainWinState = Val(GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting\MainWindow", "WindowState"))
    
    Temp = GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting", "DefPlayers")
    Parse Temp, ",", Field(), 9
    For a = 1 To 9
        gDefControl(a) = Val(Field(a))
    Next a
    
    Temp = GetRegString(HKEY_CURRENT_USER, "Software\Speedway Meeting", "DefProgMarking")
    Parse Temp, ",", Field(), 18
    For a = 1 To 17
        gDefHeatCode(a) = Left(Field(a), 2)
    Next a
    gDefScoringType = Val(Field(18))
    
    ' Sets default initialisation values if necessary
    Select Case gDefMaxAvge
        Case Is < 1, Is > 99
            gDefMaxAvge = 12
    End Select
    
    Select Case gDefHomeAdv
        Case Is < 0, Is > 1
            gDefHomeAdv = 0
    End Select
    
    Select Case gDefStartPrefs
        Case Is < 0, Is > 3
            gDefStartPrefs = 0
    End Select
    
    If gRdrFile = "" Then gRdrFile = "Lineups.rdb"
    
    Select Case MainWinX
        Case 0 To Screen.Width
            frmMainWin.Left = MainWinX
        Case Else
            frmMainWin.Left = 0
    End Select
    
    Select Case MainWinY
        Case 0 To Screen.Height
            frmMainWin.Top = MainWinY
        Case Else
            frmMainWin.Top = 0
    End Select
    
    Select Case MainWinHeight
        Case 405 To Screen.Height
            frmMainWin.Height = MainWinHeight
        Case Else
            frmMainWin.Height = Screen.Height - 1000
    End Select
      
    Select Case MainWinWidth
        Case 1680 To Screen.Width
            frmMainWin.Width = MainWinWidth
        Case Else
            If Screen.Width < 7000 Then
                frmMainWin.Width = Screen.Width
            Else
                frmMainWin.Width = 7000
            End If
    End Select
        
    Select Case MainWinState
        Case 0, 2
            frmMainWin.WindowState = MainWinState
        Case Else
            frmMainWin.WindowState = 0
    End Select
    
    For a = 1 To 9
        Select Case gDefControl(a)
            Case Is < 0, Is > 1
                gDefControl(a) = 0
        End Select
    Next a
    
    For a = 1 To 17
        If gDefHeatCode(a) = "" Then
            Select Case a
                Case 1
                    gDefHeatCode(1) = "N"
                Case 2
                    gDefHeatCode(2) = "Fn"
                Case 3
                    gDefHeatCode(3) = "N2"
                Case 4
                    gDefHeatCode(4) = "E"
                Case 5
                    gDefHeatCode(5) = "R"
                Case 6
                    gDefHeatCode(6) = "F"
                Case 7
                    gDefHeatCode(7) = "Fx"
                Case 8
                    gDefHeatCode(8) = "X"
                Case 9
                    gDefHeatCode(9) = "0"
                Case 10
                    gDefHeatCode(10) = "1"
                Case 11
                    gDefHeatCode(11) = "2"
                Case 12
                    gDefHeatCode(12) = "3"
                Case 13
                    gDefHeatCode(13) = "4"
                Case 14
                    gDefHeatCode(14) = "5"
                Case 15
                    gDefHeatCode(15) = "6"
                Case 16
                    gDefHeatCode(16) = "7"
                Case 17
                    gDefHeatCode(17) = "*"
            End Select
        End If
    Next a

    ' Determines search criteria
    gMatchWord = lvwPartial
    gMatchCase = vbTextCompare
    
    ' Gets locale-specific information
    gDecSep = GetUserLocaleInfo(LOCALE_SDECIMAL)
    gDateFmt = LCase(GetUserLocaleInfo(LOCALE_SSHORTDATE))
        
End Sub

Public Sub SaveSettings()

    Dim a As Integer                        ' Counter variable
    Dim Temp As String                      ' Temporary variable
    
    ' Saves initialisation values in Registry
    RegDeleteKey HKEY_CURRENT_USER, "SOFTWARE\Speedway Meeting"
    
    If gCompNum > 0 Then
        For a = 1 To gCompNum
            Temp = frmMainWin.mnuFNComp(a).Caption
            If frmMainWin.mnuFNComp(a).Tag <> "" Then
                Temp = Temp + ", " + frmMainWin.mnuFNComp(a).Tag
            End If
            SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting\Competitions", "MenuPos" + Format(a, "00"), Temp
        Next a
    End If
    
    SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting\MainWindow", "WindowState", Format(frmMainWin.WindowState)
    
    If frmMainWin.WindowState = vbNormal Then
        SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting\MainWindow", "Left", Format(frmMainWin.Left)
        SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting\MainWindow", "Top", Format(frmMainWin.Top)
        SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting\MainWindow", "Height", Format(frmMainWin.Height)
        SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting\MainWindow", "Width", Format(frmMainWin.Width)
    End If
    
    SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting", "Version", gVersion
    SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting", "DefMaxAvge", Format(gDefMaxAvge)
    SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting", "DefStartPrefs", Format(gDefStartPrefs)
    SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting", "DefHomeAdv", Format(gDefHomeAdv)
    SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting", "RiderFile", gRdrFile
    
    Temp = ""
    For a = 1 To 9
        Temp = Temp + Format(gDefControl(a))
        If a < 9 Then Temp = Temp + ","
    Next a
    SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting", "DefPlayers", Temp
    
    Temp = ""
    For a = 1 To 17
        Temp = Temp + gDefHeatCode(a)
        Temp = Temp + ","
    Next a
    Temp = Temp + Format(gDefScoringType)
    SaveRegString HKEY_CURRENT_USER, "Software\Speedway Meeting", "DefProgMarking", Temp
    
End Sub

Public Function GetRegString(HKEY As Long, KeyPath As String, KeyName As String) As String
       
    Dim KeyHand As Long                     ' Registry key handle
    Dim Result As Long                      ' Returned error code
    Dim ValueType As Long                   ' Key type
    Dim Buffer As String                    ' Key value
    Dim DataBufferSize As Long              ' Length of key value
    Dim ZeroPos As Integer                  ' Check variable
    
    ' Reads value of Registry key
    RegOpenKey HKEY, KeyPath, KeyHand
        
    Result = RegQueryValueEx(ByVal KeyHand, ByVal KeyName, 0&, ValueType, ByVal 0&, DataBufferSize)
    If Result = ERROR_SUCCESS Then
        If ValueType = REG_SZ Then
            Buffer = String(DataBufferSize, " ")
            Result = RegQueryValueEx(KeyHand, KeyName, 0&, 0&, ByVal Buffer, DataBufferSize)
            If Result = ERROR_SUCCESS Then
                ZeroPos = InStr(Buffer, Chr(0))
                If ZeroPos > 0 Then
                    GetRegString = Left(Buffer, ZeroPos - 1)
                Else
                    GetRegString = Buffer
                End If
            End If
        End If
    End If
    
    RegCloseKey KeyHand

End Function

Public Sub SaveRegString(HKEY As Long, KeyPath As String, KeyName As String, KeyValue As String)

    Dim KeyHand As Long                     ' Key handle
    
    ' Saves Registry key
    RegCreateKey HKEY, KeyPath, KeyHand
    RegSetValueEx KeyHand, KeyName, 0, REG_SZ, ByVal KeyValue, Len(KeyValue)
    RegCloseKey KeyHand

End Sub

Public Function CheckRegKey(HKEY As Long, KeyPath As String, KeyIdx As Long) As String

    Dim KeyHandle As Long                   ' Registry key handle
    Dim ErrorCode As Long                   ' Returned error code
    Dim KeyValue As String                  ' Registry key value
    Dim KeyValueLen As Long                 ' Length of Registry key
    Dim Data As Long                        ' Used to obtain key value
    Dim DataLen As Long                     ' Used to obtain key value
    
    ' Checks Registry key
    RegOpenKeyEx HKEY, KeyPath, 0&, KEY_READ, KeyHandle
    
    KeyValueLen = 2000
    KeyValue = String(KeyValueLen, 0)
    DataLen = 2000
    ErrorCode = RegEnumValue(KeyHandle, KeyIdx, ByVal KeyValue, KeyValueLen, 0&, REG_DWORD, ByVal Data, DataLen)
    If ErrorCode = ERROR_SUCCESS Then
        CheckRegKey = Left(KeyValue, KeyValueLen)
    End If
    
    RegCloseKey KeyHandle
    
End Function

Public Sub ResumeMeeting(Filename As String)

    Dim ScriptSize As Integer           ' Temporary variable
    
    ' Resets application initialisation flag
    gIniProc = 0
            
    If Dir(Filename) <> "" Then
        
        ' Resets meeting data arrays
        ReDim gDate(0), gCompVenue(0), gCompTitle(0), gControl(9)
        ReDim gRdrName(40), gRdrAvge(40), gRdrStatus(40), gLineupNo(40), gRidingNo(40)
        ReDim gRacePts(40), gBonusPts(40), gRideNum(40)
        ReDim gActualRides(40), gAvlRides(40), gRiding(40)
        ReDim gNomRides(40), gRdrRepRides(40), gTacSubRides(40)
        ReDim gLastRide(40), gTmName(9), gTmScore(9), gAddPts(9)
        ReDim gTbrk(40, 8), gTmTbrk(9, 8), gRdrRepFac(9, 2)
        ReDim gHeatCode(17), gHandicaps(8), gRunoffInfo(3, 2)
        ReDim gHtRef(40), gHtDetail(40, 8, 3), gHtScore(40, 4)
        ReDim gTmRnk(9), gRdrRnk(40)
        ReDim gLineup(8, 5), gRideCode(40), gRideSub(40), gCompID(8)
        
        Open Filename For Binary As #1
       
        ' Reads meeting variables
        Get #1, , ScriptSize
        Get #1, , gMaxRides
                
        ReDim gScript(ScriptSize)
        ReDim gRaceRes(40, gMaxRides)
                
        Get #1, , gScript
        Get #1, , gNumTeams
        Get #1, , gNumGroups
        Get #1, , gNumRiders
        Get #1, , gResType
        Get #1, , gNumRes
        Get #1, , gMinRides
        Get #1, , gMaxResRides
        Get #1, , gResEnable
        Get #1, , gStartPen
        Get #1, , gRunoffUse
        Get #1, , gCheckPos
        Get #1, , gAddBonus
        Get #1, , gTacSubs
        Get #1, , gTacEnable
        Get #1, , gRdrRep
        Get #1, , gTeamRes
        Get #1, , gSpclRaces
        Get #1, , gHandicaps
        Get #1, , gHeatCode
        Get #1, , gScoringType
        Get #1, , gMaxAvge
        Get #1, , gCompID
        Get #1, , gNumStarters
        Get #1, , gSupportComp
        Get #1, , gAddRdrs
        Get #1, , gProgHeats
        Get #1, , gGateFactor
        Get #1, , gControl
        Get #1, , gInteractive
        Get #1, , gStartPrefs
        Get #1, , gHomeAdv
        Get #1, , gDate
        Get #1, , gCompVenue
        Get #1, , gCompTitle
        Get #1, , gRdrName
        Get #1, , gRdrAvge
        Get #1, , gRdrStatus
        Get #1, , gLineupNo
        Get #1, , gRidingNo
        Get #1, , gRideNum
        Get #1, , gActualRides
        Get #1, , gRaceRes
        Get #1, , gRacePts
        Get #1, , gBonusPts
        Get #1, , gAvlRides
        Get #1, , gRiding
        Get #1, , gNomRides
        Get #1, , gRdrRepRides
        Get #1, , gTacSubRides
        Get #1, , gLastRide
        Get #1, , gTmName
        Get #1, , gTmScore
        Get #1, , gAddPts
        Get #1, , gTbrk
        Get #1, , gTmTbrk
        Get #1, , gRdrRepFac
        Get #1, , gHtRef
        Get #1, , gHtDetail
        Get #1, , gHtScore
        Get #1, , gTmRnk
        Get #1, , gRdrRnk
        Get #1, , gScriptPtr
        Get #1, , gLastScriptPtr
        Get #1, , gMaxHtLen
        Get #1, , gHeat
        Get #1, , gScoring
        Get #1, , gResUse
        Get #1, , gHandicapUse
        Get #1, , gNomHighest
        Get #1, , gNomLowest
        Get #1, , gTacMode
        Get #1, , gRdrRepMode
        Get #1, , gHighRdrScore
        Get #1, , gHighBnScore
        Get #1, , gHighTmScore
        Get #1, , gHighHtScore
        Get #1, , gRunoff
        Get #1, , gSubRunoff
        Get #1, , gLineup
        Get #1, , gRunoffInfo
        Get #1, , gFinished
        
        Close #1
            
        ' Updates Results Window
        DisplayResults
        frmMainWin.sbrResults.SimpleText = ""

    End If
        
End Sub

Public Sub SuspendMeeting(Filename As String)

    Dim ScriptSize As Integer           ' Temporary variable
    
    ' Writes meeting variables to file
    Open Filename For Binary As #1
    
    ScriptSize = UBound(gScript)
    
    Put #1, , ScriptSize
    Put #1, , gMaxRides
    Put #1, , gScript
    Put #1, , gNumTeams
    Put #1, , gNumGroups
    Put #1, , gNumRiders
    Put #1, , gResType
    Put #1, , gNumRes
    Put #1, , gMinRides
    Put #1, , gMaxResRides
    Put #1, , gResEnable
    Put #1, , gStartPen
    Put #1, , gRunoffUse
    Put #1, , gCheckPos
    Put #1, , gAddBonus
    Put #1, , gTacSubs
    Put #1, , gTacEnable
    Put #1, , gRdrRep
    Put #1, , gTeamRes
    Put #1, , gSpclRaces
    Put #1, , gHandicaps
    Put #1, , gHeatCode
    Put #1, , gScoringType
    Put #1, , gMaxAvge
    Put #1, , gCompID
    Put #1, , gNumStarters
    Put #1, , gSupportComp
    Put #1, , gAddRdrs
    Put #1, , gProgHeats
    Put #1, , gGateFactor
    Put #1, , gControl
    Put #1, , gInteractive
    Put #1, , gStartPrefs
    Put #1, , gHomeAdv
    Put #1, , gDate
    Put #1, , gCompVenue
    Put #1, , gCompTitle
    Put #1, , gRdrName
    Put #1, , gRdrAvge
    Put #1, , gRdrStatus
    Put #1, , gLineupNo
    Put #1, , gRidingNo
    Put #1, , gRideNum
    Put #1, , gActualRides
    Put #1, , gRaceRes
    Put #1, , gRacePts
    Put #1, , gBonusPts
    Put #1, , gAvlRides
    Put #1, , gRiding
    Put #1, , gNomRides
    Put #1, , gRdrRepRides
    Put #1, , gTacSubRides
    Put #1, , gLastRide
    Put #1, , gTmName
    Put #1, , gTmScore
    Put #1, , gAddPts
    Put #1, , gTbrk
    Put #1, , gTmTbrk
    Put #1, , gRdrRepFac
    Put #1, , gHtRef
    Put #1, , gHtDetail
    Put #1, , gHtScore
    Put #1, , gTmRnk
    Put #1, , gRdrRnk
    Put #1, , gScriptPtr
    Put #1, , gLastScriptPtr
    Put #1, , gMaxHtLen
    Put #1, , gHeat
    Put #1, , gScoring
    Put #1, , gResUse
    Put #1, , gHandicapUse
    Put #1, , gNomHighest
    Put #1, , gNomLowest
    Put #1, , gTacMode
    Put #1, , gRdrRepMode
    Put #1, , gHighRdrScore
    Put #1, , gHighBnScore
    Put #1, , gHighTmScore
    Put #1, , gHighHtScore
    Put #1, , gRunoff
    Put #1, , gSubRunoff
    Put #1, , gLineup
    Put #1, , gRunoffInfo
    Put #1, , gFinished
    
    Close #1
    
End Sub

Public Sub SetMenuCols()

    Dim a As Integer                        ' Counter variable
    Dim ok As Integer                       ' Check variable
    Dim ColBrk As Integer                   ' Number of entries per column in menu
    Dim MenuHand As Long                    ' API menu handle
    Dim MenuInfo As MENUITEMINFO            ' Passes values with API call
    
    ' Gets menu handle
    MenuHand = GetSubMenu(GetSubMenu(GetMenu(frmMainWin.hWnd), 0&), 0&)
    If MenuHand = 0 Then
        MenuHand = GetSubMenu(GetSubMenu(GetMenu(frmMainWin.hWnd), 1&), 0&)
    End If
    
    ' Determines number of entries per column
    a = 1
    Do
        If CInt((gCompNum + 2) * 255 / a) <= Screen.Height Then
            ColBrk = Int((gCompNum + 2) / a)
            ok = 1
        Else
            a = a + 1
        End If
    Loop Until ok = 1
    
    ' Inserts column breaks into menu
    For a = 1 To gCompNum
        If (a - 1) Mod ColBrk = 0 And a > 1 Then
            MenuInfo.cbSize = Len(MenuInfo)
            MenuInfo.fMask = MIIM_TYPE
            MenuInfo.fType = MFT_STRING
            MenuInfo.dwTypeData = Space(256)
            MenuInfo.cch = Len(MenuInfo.dwTypeData)
            GetMenuItemInfo MenuHand, a - 1, True, MenuInfo
            MenuInfo.fType = RGB_STARTNEWCOLUMNWITHVERTBAR
            MenuInfo.fMask = MIIM_TYPE
            SetMenuItemInfo MenuHand, a - 1, True, MenuInfo
        End If
    Next a

End Sub

Public Function Handicap(Rider As Integer) As Integer
    
    ' Calculates rider handicaps
    If gHandicapUse = 1 Then
        Select Case gLastRide(Rider)
            Case 9 To 16
                Handicap = gHandicaps(gLastRide(Rider) - 8)
            Case Else
                Handicap = gHandicaps(1)
        End Select
    End If
    
End Function
